
#include "calViolation.h"
#include "anatomy.h"


violateTuple *violateTuple_new()
{
	violateTuple *returnValue;

	returnValue = (violateTuple *) malloc(sizeof(violateTuple));
	memset(returnValue, 0, sizeof(violateTuple));

	return returnValue;
}

violateGroup *violateGroup_new()
{
	violateGroup *returnValue;

	returnValue = (violateGroup *) malloc(sizeof(violateGroup));
	memset(returnValue, 0, sizeof(violateGroup));

	return returnValue;
}

void violateGroup_insert(violateGroup *aViolateGroup, violateTuple *aViolateTuple)
{
	int noOfTuple;
	violateTuple **tupleList;
	violateTuple **newTupleList;

	noOfTuple = aViolateGroup->noOfTuple;
	tupleList = aViolateGroup->tupleList;

	if(noOfTuple == 0)
	{
		newTupleList = (violateTuple **) malloc(sizeof(violateTuple *));
	}
	else
	{
						//{
						//	int k;
						//	for (k = 0; k < noOfTuple; k++)
						//	{
						//		printf(" @@@@@@@@@@2  before*****%d. (%d, %p)**********\n", k, noOfTuple, tupleList[k]);
						//	}
						//}
		newTupleList = (violateTuple **) realloc(tupleList, sizeof(violateTuple *)*(noOfTuple+1));
		//memcpy(newTupleList, tupleList, sizeof(violateTuple *)*noOfTuple);

						//{
						//	int k;

						//	for (k = 0; k < noOfTuple; k++)
						//	{
						//		printf(" @@@@@@@@@@2  after*****%d. (%d, %p)**********\n", k, noOfTuple, newTupleList[k]);
						//	}
						//}
	}
	newTupleList[noOfTuple] = aViolateTuple;

	aViolateGroup->noOfTuple++;
	aViolateGroup->tupleList = newTupleList;
}	



float findProbMemberJLinkToSenValue(int memberJ, int aSenValue, float sumProb, float *probList, int **allPoss, int noOfPoss)
{
	float returnValue;
	float temp;

	int i;

	temp = 0;
	for (i = 0; i < noOfPoss; i++)
	{
		if (allPoss[i][memberJ] == aSenValue)
		{
			temp += probList[i];
		}
	}

	returnValue = (float) ( temp/sumProb);

	return returnValue;
}

void findViolationFromNoSignature(configure *config, signatureGroup *aSigGroup, violateGroup *aViolateGroup, equivalenceClass *eqClass, int noOfSenValue, term ***allTerm, int ***allPoss, int *noOfPoss, float *aVector, float violateThreshold)
{
	violateTuple *aViolateTuple;

	int i, j, k;
	int noOfMember;

	int *sigList;

	int aSenValue;

	float aProb;
	int anIndex;

	int *member;
	int memberID;

	float *probList;
	float sumProb;

	int sigID;
	signature *aSignature;


	equivalenceTuple *oneEqTuple;

	int noOfEqTuple;
	equivalenceTuple **eqTupleList;

	noOfEqTuple = eqClass->noOfEqClass;
	eqTupleList = eqClass->eqClass;

	for (i = 0; i < noOfEqTuple; i++)
	{
		oneEqTuple = eqTupleList[i];

		noOfMember = oneEqTuple->noOfMember;
		member = oneEqTuple->member;
		sigList = oneEqTuple->signatureID;

		// find probList
		probList = (float *) malloc(sizeof(float)*noOfPoss[i]);
		memset(probList, 0, sizeof(float)*noOfPoss[i]);
		for (j = 0; j < noOfPoss[i]; j++)
		{
			//anIndex = j+1;
			anIndex = j;
			probList[j] = term_calculateValue(allTerm[i][anIndex], aVector);
		}

		// calculate sumProb
		sumProb = 0;
		for (j = 0; j < noOfPoss[i]; j++)
		{
			sumProb += probList[j];
		}

		for (j = 0; j < noOfMember; j++)
		{
			memberID = member[j];
			//if (sigList[j] == -1)
			{
				for (k = 0; k < noOfSenValue; k++)
				{
					aSenValue = k;

//if ((i == 0) && (j == 1) && (k == 1))
//{
//	printf("");
//}

					if ((config->senStartNo <= aSenValue) && (aSenValue <= config->senEndNo))
					{
						// find the prob. that member j is linked to senValue k
						aProb = findProbMemberJLinkToSenValue(j, aSenValue, sumProb, probList, allPoss[i], noOfPoss[i]);
	if (aProb > 1)
	{
		printf("");
	}

						if (aProb > violateThreshold)
						{

							// global (regardless of sen. value)
							if (aProb > g_prob[memberID])
							{
								g_prob[memberID] = aProb;
							}

							aViolateTuple = violateTuple_new();

							aViolateTuple->id = oneEqTuple->member[j];

							// sig
							if (sigList[j] == -1)
							{
								aViolateTuple->noOfAttr = 0;
								aViolateTuple->content = NULL;
								aViolateTuple->dimNo = NULL;
							}
							else
							{
								
								sigID = sigList[j];
								aSignature = aSigGroup->sigList[sigID];

								aViolateTuple->noOfAttr = aSignature->noOfAttr;
								aViolateTuple->content = (dimension *) malloc(sizeof(dimension)*aViolateTuple->noOfAttr);
								aViolateTuple->dimNo = (int *) malloc(sizeof(int)*aViolateTuple->noOfAttr);
								memcpy(aViolateTuple->content, aSignature->content, sizeof(dimension)*aViolateTuple->noOfAttr);
								memcpy(aViolateTuple->dimNo, aSignature->dimNo, sizeof(int)*aViolateTuple->noOfAttr);

							}
							
							aViolateTuple->eqID = i;

							//
							aViolateTuple->senValue = aSenValue;
							aViolateTuple->prob = aProb;

							//{
							//	int k;

							//	for (k = 0; k < aViolateGroup->noOfTuple; k++)
							//	{
							//		printf(" ****before*****%d. (%d, %p)**********\n", k, aViolateGroup->noOfTuple, aViolateGroup->tupleList[k]);
							//	}
							//}

							violateGroup_insert(aViolateGroup, aViolateTuple);

							//{
							//	int k;

							//	for (k = 0; k < aViolateGroup->noOfTuple; k++)
							//	{
							//		printf(" ****after*****%d. (%d, %p)**********\n", k, aViolateGroup->noOfTuple, aViolateGroup->tupleList[k]);
							//	}
							//}
						}
					}
				}
			}
		}

		free(probList);
	}
}

void findViolationForOneVariableTerm(violateGroup *aViolateGroup, term *aTerm, equivalenceClass *eqClass, int sigID, int aSenValue, signature *aSignature, float *aVector, float violateThreshold)
{
	int noOfOperand;
	term **operandList;

	term *aSingleTerm;

	float aValue;

	int noOfOccur;

	violateTuple *aViolateTuple;

	int i, j;

	equivalenceTuple *oneEqTuple;
	int eqID;

	int noOfMatch;

	int *eqIDMatchList;


	noOfOperand = aTerm->noOfOperand;
	operandList = aTerm->operandList;

	if (noOfOperand > 1)
	{
		eqIDMatchList = sig_findEqClassWithSignature(eqClass, sigID, &noOfMatch);

		for (i = 1; i < noOfOperand; i++)
		{
			aSingleTerm = operandList[i];

			//printf("~~~~~~~~~~~~~~~~\n");
			//term_print(aSingleTerm);
			//printf("\n");
			//printf("~~~~~~~~~~~~~~~~\n");
			//printf("%.4f %.4f %.4f %.4f\n", aVector[0], aVector[1], aVector[2], aVector[3]);
			//printf("~~~~~~~~~~~~~~~~\n");

			aValue = term_calculateValue(aSingleTerm, aVector);

			eqID = eqIDMatchList[i-1];
			oneEqTuple = eqClass->eqClass[eqID];
			noOfOccur = possWorld_findNoOfMatchInOneEqClass(oneEqTuple, sigID);

			aValue /= noOfOccur;

			if (aValue > violateThreshold)
			{
				for (j = 0; j < oneEqTuple->noOfMember; j++)
				{
					if (oneEqTuple->signatureID[j] == sigID)
					{
						aViolateTuple = violateTuple_new();

						aViolateTuple->id = oneEqTuple->member[j];

						// sig
						aViolateTuple->noOfAttr = aSignature->noOfAttr;
						aViolateTuple->content = (dimension *) malloc(sizeof(dimension)*aViolateTuple->noOfAttr);
						aViolateTuple->dimNo = (int *) malloc(sizeof(int)*aViolateTuple->noOfAttr);
						memcpy(aViolateTuple->content, aSignature->content, sizeof(dimension)*aViolateTuple->noOfAttr);
						memcpy(aViolateTuple->dimNo, aSignature->dimNo, sizeof(int)*aViolateTuple->noOfAttr);
						aViolateTuple->eqID = eqID;

						//
						aViolateTuple->senValue = aSenValue;
						aViolateTuple->prob = aValue;

						violateGroup_insert(aViolateGroup, aViolateTuple);
					}
				}
			}
		}

		if (noOfMatch > 0)
		{
			free(eqIDMatchList);
		}
	}


}


violateGroup *findViolationForAllVariableTerm(configure *config, term **aTerm, equivalenceClass *eqClass, int noOfSenValue, signatureGroup *aSigGroup, float *aVector, float violateThreshold)
{
	violateGroup *returnValue;
	int i, j;
	int noOfSignature;
	signature **sigList;

	int sigID, aSenValue;
	int varNo;

	signature *aSignature;

	returnValue = violateGroup_new();

	noOfSignature = aSigGroup->noOfSig;
	sigList = aSigGroup->sigList;

	for (i = 0; i < noOfSignature; i++)
	{
		sigID = i;

		aSignature = sigList[i];

		for (j = 0; j < noOfSenValue; j++)
		{
			aSenValue = j;

			if ((config->senStartNo <= aSenValue) && (aSenValue <= config->senEndNo))
			{
				varNo = sigID*noOfSenValue + aSenValue;

				
				findViolationForOneVariableTerm(returnValue, aTerm[varNo], eqClass, sigID, aSenValue, aSignature, aVector, violateThreshold);
			}
		}
	}


	return returnValue;
}

void violateTuple_print(FILE *filePtr, violateTuple *aViolateTuple, data *aData, equivalenceClass *eqClass, int noOfSenValue, float *aVector)
{
	int i, j;
	int tupleID;

	equivalenceTuple *oneEqTuple;
	int noOfMember;

	int *sigList;
	int sigID;

	int eqID;

	int varNo;

	int *member;
	int memberID;

	int aSenValue;
	float prob;

	fprintf(filePtr, " ----------------------------\n");
	fprintf(filePtr, "  id = %d  ", aViolateTuple->id);
	tupleID = aViolateTuple->id;
	fprintf(filePtr, " (");
	for (i = 0; i < aData->noOfDim; i++)
	{
		fprintf(filePtr, "%d", aData->tupleList[tupleID].content[i].value);
		if (i != aData->noOfDim-1)
		{
			fprintf(filePtr, ",");
		}
	}
	fprintf(filePtr, ")\n");
	fprintf(filePtr, "  senValue = %d\n", aViolateTuple->senValue);
	aSenValue = aViolateTuple->senValue;
	fprintf(filePtr, "  prob. = %.10f\n", aViolateTuple->prob);
	fprintf(filePtr, "  eqID  = %d\n", aViolateTuple->eqID);
	eqID = aViolateTuple->eqID;
	fprintf(filePtr, "  no. of Attr = %d\n", aViolateTuple->noOfAttr);
	for (i = 0; i < aViolateTuple->noOfAttr; i++)
	{
		fprintf(filePtr, "    (dimNo=%d, value=%d) ", aViolateTuple->dimNo[i], aViolateTuple->content[i].value);
	}
	fprintf(filePtr, "\n");

	// print signature
	oneEqTuple = eqClass->eqClass[eqID];
	member = oneEqTuple->member;
	noOfMember = oneEqTuple->noOfMember;
	sigList = oneEqTuple->signatureID;
	for (i = 0; i < noOfMember; i++)
	{
		sigID = sigList[i];

		memberID = member[i];

		if (sigID == -1)
		{
			prob = -1;
		}
		else
		{
			varNo = sigID*noOfSenValue + aSenValue;
			prob = aVector[varNo];
		}
		fprintf(filePtr, "    Member %d. id=%d  sigID=%d  prob=%.6f  ", i, memberID, sigID, prob);
		fprintf(filePtr, "(");
		for (j = 0; j < aData->noOfDim; j++)
		{
			fprintf(filePtr, "%d", aData->tupleList[memberID].content[j].value);
			if (j != aData->noOfDim-1)
			{
				fprintf(filePtr, ", ");
			}
		}
		fprintf(filePtr, ")");
		if (sigID != -1)
		{
			fprintf(filePtr, "(");
			for (j = 0; j < noOfSenValue; j++)
			{
				aSenValue = j;
				varNo = sigID*noOfSenValue + aSenValue;
				prob = aVector[varNo];
				fprintf(filePtr, "%d=%.10f", j, prob);
				if (j != noOfSenValue-1)
				{
					fprintf(filePtr, ", ");
				}
			}
			fprintf(filePtr, ")");
		}
		fprintf(filePtr, "\n");
	}
	
}

void violateGroup_print(FILE *filePtr, violateGroup *aViolateGroup, data *aData, equivalenceClass *eqClass, int noOfSenValue, float *aVector)
{
	int noOfTuple;
	violateTuple **tupleList;

	int i;

	noOfTuple = aViolateGroup->noOfTuple;
	tupleList = aViolateGroup->tupleList;

	printf("No. of violated tuples : %d\n", noOfTuple);
	for (i = 0; i < noOfTuple; i++)
	{
		violateTuple_print(filePtr, tupleList[i], aData, eqClass, noOfSenValue, aVector);
	}
}

int calViolation_calculateSampleSize(float error, float sigma)
{
	int returnValue;

	double aValue;

	aValue = 1.0/(2*error*error)*log(2.0/sigma);

	returnValue = ceiling(aValue);

	return returnValue;
}


float *calViolation_getInitialVector(equivalenceClass *eqClass, signatureGroup *aSigGroup, int noOfSenValue, float **realReturnValueOut)
{
	float *returnValue;
	float *realReturnValue;

	int i, j, k;
	int noOfSig;

	signature **sigList;

	int noOfTerm;

	int noOfEqTuple;
	equivalenceTuple **eqTupleList;
	equivalenceTuple *aEqTuple;

	int *sigIDList;
	int noOfMember;

	int *noOfEachSen;

	float *count;
	float *realCount;
	int noOfRec;

	int *total;

	dimension *senValue;

	int sigID;
	int aSenValue;
	int varNo;
	float aValue;

	noOfSig = aSigGroup->noOfSig;
	sigList = aSigGroup->sigList;

	noOfTerm = noOfSig*noOfSenValue;

	returnValue = (float *) malloc(sizeof(float)*noOfTerm);
	memset(returnValue, 0, sizeof(float)*noOfTerm);

	realReturnValue = (float *) malloc(sizeof(float)*noOfTerm);
	memset(realReturnValue, 0, sizeof(float)*noOfTerm);

	count = (float *) malloc(sizeof(float)*noOfTerm);
	memset(count, 0, sizeof(float)*noOfTerm);

	realCount = (float *) malloc(sizeof(float)*noOfTerm);
	memset(realCount, 0, sizeof(float)*noOfTerm);

	total = (int *) malloc(sizeof(int)*noOfSig);
	memset(total, 0, sizeof(int)*noOfSig);


	noOfEqTuple = eqClass->noOfEqClass;
	eqTupleList = eqClass->eqClass;

	for (i = 0; i < noOfEqTuple; i++)
	{
		aEqTuple = eqTupleList[i];

		noOfMember = aEqTuple->noOfMember;

		sigIDList = aEqTuple->signatureID;

		noOfEachSen = aEqTuple->noOfEachSen;

		senValue = aEqTuple->senValue;

		for (j = 0; j < noOfMember; j++)
		{
			sigID = sigIDList[j];

			if (sigID != -1)
			{
			
				for (k = 0; k < noOfSenValue; k++)
				{
					aSenValue = k;

					varNo = sigID*noOfSenValue + aSenValue;

					aValue = (float)( noOfEachSen[k]/((double) noOfMember));

					count[varNo] += aValue;
				}

				// assume one level
				aSenValue = senValue[j].value;
				varNo = sigID*noOfSenValue + aSenValue;
				realCount[varNo] += 1;

				total[sigID]++;
			}

			
		}
	}

	for (i = 0; i < noOfSig; i++)
	{
		noOfRec = sigList[i]->noOfMember;
		for (j = 0; j < noOfSenValue; j++)
		{
			varNo = i*noOfSenValue + j;

			//aValue = (float) (count[varNo]/((double) noOfRec));
			aValue = (float) (count[varNo]/((double) total[i]));
			returnValue[varNo] = aValue;

			//
			aValue = (float) (realCount[varNo]/((double) total[i]));
			realReturnValue[varNo] = aValue;
		}
	}

	free(total);

	free(count);
	free(realCount);

	(*realReturnValueOut) = realReturnValue;

	return returnValue;
}

double violate_calculateRealEstDiff(float *real, float *est, int noOfSig, int noOfSenValue, double *relative_error)
{
	double returnValue;
	float diff, relative;
	int noOfTerm;
	int i;

	float sum;
	float avgValue;

	noOfTerm = noOfSig*noOfSenValue;

	returnValue = 0;
	(*relative_error) = 0;
	relative = 0;
	sum = 0;
	for (i = 0; i < noOfTerm; i++)
	{
		diff = real[i] - est[i];
		if (diff < 0)
		{
			diff *= -1;
		}

		/*if (real[i] == 0)
		{
			relative = 0;
		}
		else
		{
			relative = diff/real[i];
		}*/
		relative += diff;

		sum += real[i];

		returnValue += diff;
		if ((i + noOfSenValue -1)%noOfSenValue == 0)
		{
			avgValue = sum/noOfSenValue;

			relative /= avgValue;
			(*relative_error) += relative;
			relative = 0;
			sum = 0;
		}
	}

	returnValue /= noOfSig;
	returnValue /= noOfSenValue;

	(*relative_error) /= noOfSig;
	(*relative_error) /= noOfSenValue;

	return returnValue;
}

violateStatistics *violateStatistics_new()
{
	violateStatistics *returnValue;

	returnValue = (violateStatistics *) malloc(sizeof(violateStatistics));
	memset(returnValue, 0, sizeof(violateStatistics));

	returnValue->max_noOfViolateTuple = -1;
	returnValue->avg_noOfViolateTuple = -1;
	returnValue->sum_noOfViolateTuple = -1;
	returnValue->min_noOfViolateTuple = -1;

	returnValue->max_avgViolateProb = -1;
	returnValue->avg_avgViolateProb = -1;
	returnValue->sum_avgViolateProb = -1;
	returnValue->min_avgViolateProb = -1;

	returnValue->count = 0;

	return returnValue;
}

void violateStatistics_update(violateStatistics *aViolateStatistics, violateGroup *aViolateGroup)
{
	int noOfViolateTuple;
	violateTuple **violateTupleList;

	int i;

	violateTuple *aViolateTuple;

	double sum_prob;
	float avg_prob;


	noOfViolateTuple = aViolateGroup->noOfTuple;
	violateTupleList = aViolateGroup->tupleList;
//printf("~~~~~~~~~~~~~~1.1\n");
	if (noOfViolateTuple > 0)
	{
//printf("~~~~~~~~~~~~~~1.1.1  (noOfViolateTuple=%d)\n", noOfViolateTuple);
		sum_prob = 0;
		for (i = 0; i < noOfViolateTuple; i++)
		{
//printf("~~~~~~~~~~~~~~  1.1.1.%d  - 1\n", i);
			aViolateTuple = violateTupleList[i];
//printf("~~~~~~~~~~~~~~  1.1.1.%d  - 2 (%p)\n", i, aViolateTuple);
			sum_prob += aViolateTuple->prob;
//printf("~~~~~~~~~~~~~~  1.1.1.%d  - 3\n", i);
		}
//printf("~~~~~~~~~~~~~~1.2\n");
		avg_prob = (float) (sum_prob/noOfViolateTuple);
//printf("~~~~~~~~~~~~~~1.3\n");
		if (aViolateStatistics->avg_avgViolateProb == -1)
		{
			aViolateStatistics->max_noOfViolateTuple = noOfViolateTuple;
			aViolateStatistics->avg_noOfViolateTuple = (float) noOfViolateTuple;
			aViolateStatistics->sum_noOfViolateTuple = noOfViolateTuple;
			aViolateStatistics->min_noOfViolateTuple = noOfViolateTuple;

			aViolateStatistics->max_avgViolateProb = avg_prob;
			aViolateStatistics->avg_avgViolateProb = avg_prob;
			aViolateStatistics->sum_avgViolateProb = avg_prob;
			aViolateStatistics->min_avgViolateProb = avg_prob;
//printf("~~~~~~~~~~~~~~1.4\n");
			aViolateStatistics->count = 1;
		}
		else
		{
//printf("~~~~~~~~~~~~~~1.5.0\n");
			aViolateStatistics->count++;
//printf("~~~~~~~~~~~~~~1.5\n");
			//
			aViolateStatistics->sum_noOfViolateTuple += noOfViolateTuple;
			aViolateStatistics->avg_noOfViolateTuple = (float) (aViolateStatistics->sum_noOfViolateTuple/((double)aViolateStatistics->count));
			if (noOfViolateTuple > aViolateStatistics->max_noOfViolateTuple)
			{
				aViolateStatistics->max_noOfViolateTuple = noOfViolateTuple;
			}
//printf("~~~~~~~~~~~~~~1.6\n");
			if (noOfViolateTuple < aViolateStatistics->min_noOfViolateTuple)
			{
				aViolateStatistics->min_noOfViolateTuple = noOfViolateTuple;
			}
//printf("~~~~~~~~~~~~~~1.7\n");
			//
			aViolateStatistics->sum_avgViolateProb += avg_prob;
			aViolateStatistics->avg_avgViolateProb = (float) (aViolateStatistics->sum_avgViolateProb/((double)aViolateStatistics->count));
			if (avg_prob > aViolateStatistics->max_avgViolateProb)
			{
				aViolateStatistics->max_avgViolateProb = avg_prob;
			}
//printf("~~~~~~~~~~~~~~1.8\n");
			if (avg_prob < aViolateStatistics->min_avgViolateProb)
			{
				aViolateStatistics->min_avgViolateProb = avg_prob;
			}
		}
	}

}

void violateStatistics_print(FILE *filePtr, violateStatistics *aViolateStatistics)
{
	fprintf(filePtr, "%d\n", aViolateStatistics->max_noOfViolateTuple);
	fprintf(filePtr, "%.10f\n", aViolateStatistics->avg_noOfViolateTuple);
	fprintf(filePtr, "%d\n", aViolateStatistics->sum_noOfViolateTuple);
	fprintf(filePtr, "%d\n", aViolateStatistics->min_noOfViolateTuple);

	fprintf(filePtr, "\n");

	fprintf(filePtr, "%.10f\n", aViolateStatistics->max_avgViolateProb);
	fprintf(filePtr, "%.10f\n", aViolateStatistics->avg_avgViolateProb);
	fprintf(filePtr, "%.10f\n", aViolateStatistics->sum_avgViolateProb);
	fprintf(filePtr, "%.10f\n", aViolateStatistics->min_avgViolateProb);

	fprintf(filePtr, "\n");

	fprintf(filePtr, "%d\n", aViolateStatistics->count);

	
}

void transformToBinary_forEqTuple(configure *config, equivalenceTuple *aEqTuple)
{
	int noOfMember;
	dimension *senValueList;

	int i;
	int aSenValue;
	
	noOfMember = aEqTuple->noOfMember;
	senValueList = aEqTuple->senValue;
	
	for (i = 0; i < noOfMember; i++)
	{
		aSenValue = senValueList[i].value;
		if ((config->senStartNo <= aSenValue) && (aSenValue <= config->senEndNo))
		{
			senValueList[i].value = 1;
		}
		else
		{
			senValueList[i].value = 0;
		}
	}
}


void transformToBinary_forTuple(configure *config, tuple *aTuple, int noOfDim)
{
	int aSenValue;

	aSenValue = aTuple->content[noOfDim-1].value;

	if ((config->senStartNo <= aSenValue) && (aSenValue <= config->senEndNo))
	{
		aTuple->content[noOfDim-1].value = 1;
	}
	else
	{
		aTuple->content[noOfDim-1].value = 0;
	}
}

void transformToBinaryData(configure *config, equivalenceClass *eqClass, data *aData)
{
	int noOfEqTuple;
	equivalenceTuple **eqTupleList;
	equivalenceTuple *oneEqTuple;

	int i;

	int noOfTuple;
	tuple *tupleList;

	tuple *oneTuple;

	int noOfDim;

	eqTupleList = eqClass->eqClass;
	noOfEqTuple = eqClass->noOfEqClass;

	for (i = 0; i < noOfEqTuple; i++)
	{
		oneEqTuple = eqTupleList[i];

		transformToBinary_forEqTuple(config, oneEqTuple);
	}


	noOfTuple = aData->noOfTuple;
	tupleList = aData->tupleList;

	noOfDim = aData->noOfDim;

	for (i = 0; i < noOfTuple; i++)
	{
		oneTuple = &(tupleList[i]);

		transformToBinary_forTuple(config, oneTuple, noOfDim);
	}
}

// remember to set oneEqTuple->signatureID to be NULL
void calculateViolation(FILE *filePtr, configure *config, data *aData, int sampleThreshold, float violateThreshold, equivalenceClass *eqClass)
{
	char *violateStatFilename = "violateStat.txt";
	FILE *violateStatFilePtr;

	signatureGroupGroup *aSigGroupGroup;
	signatureGroup **signatureType;
	int noOfSignatureType;

	term ***allTerm_eqClass;
	int ***allPoss;
	int *noOfPoss;

	int noOfTuple;
	int noOfSenValue;

	float *finalVector;
	float *initVector;

	signatureGroup *aSignatureGroup;

	int i, j;

	term **allTerm_var;
	int noOfDim;

	int noOfTerm;

	int *mapTupleList;

	int size;
	float *actualDist;

	double avgDistDiff;
	double avgDistDiff_rel;
	int noOfAvgDistDiff;

	violateGroup *aViolateGroup;

	violateStatistics *aViolateStatistics;

	signatureGroupGroup *newSigGroupGroup;

	aViolateStatistics = violateStatistics_new();

	noOfTuple = aData->noOfTuple;
	noOfDim = aData->noOfDim;
	noOfSenValue = aData->dimSize[noOfDim-1];

	

	//
	g_prob = (float *) malloc(sizeof(float)*noOfTuple);
	memset(g_prob, 0, sizeof(float)*noOfTuple);

	aSigGroupGroup = sig_createRealSignatureForMultipleAttr(aData, sampleThreshold);

	avgDistDiff = 0;
	avgDistDiff_rel = 0;
	noOfAvgDistDiff = 0;
	size = 1;
	while (aSigGroupGroup->noOfGroup > 0)
	{
		
		printf(" ~~~~ Processing signature of size %d...\n", size);
		noOfSignatureType = aSigGroupGroup->noOfGroup;
		signatureType =  aSigGroupGroup->groupList;

		
//printf(" @@@@@@@@@@@@@1\n");
		for (i = 0; i < noOfSignatureType; i++)
		{
//printf(" @@@@@@@@@@@@@2 (i=%d)\n", i);
			aSignatureGroup = signatureType[i];

			if (aSignatureGroup->noOfSig > 0)
			{
//printf(" @@@@@@@@@@@@@3\n");
				//
				printf("Creating tuple map signature...\n");
				mapTupleList = sig_createTupleMapSignature(aSignatureGroup, noOfTuple);
//printf(" @@@@@@@@@@@@@4\n");
				//
				sig_createSigNoForAllEqClass(eqClass, mapTupleList);
//printf(" @@@@@@@@@@@@@5\n");
				// initial vector
				noOfTerm = aSignatureGroup->noOfSig*noOfSenValue;
//printf(" @@@@@@@@@@@@@6\n");
				//initVector = (float *) malloc(sizeof(float)*noOfTerm);
				//memset(initVector, 0, sizeof(float)*noOfTerm);
				//for (i = 0; i < noOfTerm; i++)
				//{
				//	initVector[i] = (float) (1.0/noOfSenValue);
				//}
				printf("Finding inital vectors...\n");
				initVector = calViolation_getInitialVector(eqClass, aSignatureGroup, noOfSenValue, &actualDist);
//printf(" @@@@@@@@@@@@@7\n");
				// create expressions
				printf("Creating expressions...\n");
				allTerm_var = possWorld_createExpressionForAllVariable(&allTerm_eqClass, &allPoss, &noOfPoss, noOfSenValue, eqClass, noOfTuple, aSignatureGroup, mapTupleList);
//printf(" @@@@@@@@@@@@@8\n");
				//{
				//	int k;
				//	for (k = 0; k < 20; k++)
				//	{

				// newton
				finalVector = newton_main(allTerm_var, noOfTerm, initVector);
//printf(" @@@@@@@@@@@@@9\n");
				//	if (k != 19)
				//	{	
				//		free(finalVector);
				//	}
				//	}
				//}

				if (finalVector == NULL)
				{
				}
				else
				{
				// calculate the difference
				avgDistDiff += violate_calculateRealEstDiff(actualDist, finalVector, aSignatureGroup->noOfSig, noOfSenValue, &avgDistDiff_rel);
				noOfAvgDistDiff++;

				

				// find violations
				//printf(" Finding Violated tuples from Signature...");
				//aViolateGroup = findViolationForAllVariableTerm(config, allTerm_var, eqClass, noOfSenValue, aSignatureGroup, finalVector, violateThreshold);
				//printf(" (no. of violated tuples = %d)\n", aViolateGroup->noOfTuple);
				aViolateGroup = violateGroup_new();
//printf(" @@@@@@@@@@@@@10\n");
				printf(" Finding Violated tuples from no signatures...");
				findViolationFromNoSignature(config, aSignatureGroup, aViolateGroup, eqClass, noOfSenValue, allTerm_eqClass, allPoss, noOfPoss, finalVector, violateThreshold);
				printf(" (no. of violated tuples = %d)\n", aViolateGroup->noOfTuple);
//printf("~~~~~~~~~~~1\n");
				// make statistics
				violateStatistics_update(aViolateStatistics, aViolateGroup);
//printf("~~~~~~~~~~~2\n");
//printf(" @@@@@@@@@@@@@11\n");
				// print
				violateGroup_print(filePtr, aViolateGroup, aData, eqClass, noOfSenValue, finalVector);
//printf("~~~~~~~~~~~3\n");
				free(finalVector);
				}

				free(initVector);
				free(actualDist);

				free(mapTupleList);

				for (j = 0; j < aSignatureGroup->noOfSig*noOfSenValue; j++)
				{
					//*** 1
					term_free(allTerm_var[j]);
					//*** temp
				}
				free(allTerm_var);

				// free

				for (j = 0; j < eqClass->noOfEqClass; j++)
				{
					if (allPoss[j] != NULL)
					{
						free(allPoss[j]);
					}
					if (allTerm_eqClass[j] != NULL)
					{
						free(allTerm_eqClass[j]);
					}
				}
				free(allPoss);
				free(noOfPoss);
				free(allTerm_eqClass);
			}
		}

		newSigGroupGroup = sig_createSignatureGroupFromLowerLevel(aSigGroupGroup, sampleThreshold);

		sigGroupGroup_free(aSigGroupGroup);

		aSigGroupGroup = newSigGroupGroup;


		//printf(" ############## no. of types = %d\n", aSigGroupGroup->noOfGroup);
		//printf(" ############## no. of grouops for index 0 = %d\n", aSigGroupGroup->groupList[0]->noOfSig);

		size++;
	}

	sigGroupGroup_free(aSigGroupGroup);

	//
	if (noOfAvgDistDiff == 0)
	{
		avgDistDiff = 0;
		avgDistDiff_rel = 0;
	}
	else
	{
		avgDistDiff /= noOfAvgDistDiff;
		avgDistDiff_rel /= noOfAvgDistDiff;
	}

	// 
	violateStatFilePtr = (FILE *) fopen(violateStatFilename, "w");
	if (violateStatFilePtr == NULL)
	{
		printf("File %s cannot be opened!\n", violateStatFilename);
	}
	violateStatistics_print(violateStatFilePtr, aViolateStatistics);
	fprintf(violateStatFilePtr, "\n");
	fprintf(violateStatFilePtr, "%.10f\n", avgDistDiff);
	fprintf(violateStatFilePtr, "%.10f\n", avgDistDiff_rel);
	fclose(violateStatFilePtr);	
}


void calViolationMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	int isAlphaK;

	int kAnonymity;
	int noOfQID;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;
	//mechAllGroup *finalMechAllGroup;

	int noOfValueInSenAttr;

	int noOfSlot;
	float delta;

	float maxValue;

	//double avgRelError;

	int i;
	//double *probList;

	//allCondition *aAllCondition;

	//twoTable *finalTable;
	//FILE *filePtr;

	int senStartNo, senEndNo;

	//int nonSenStartNo;
	//int nonSenEndNo;

	//double infoLoss, distortion;
	//int noOfSenChange;

	dimensionSetSet *sensitiveSetSet;
	//dimensionSet *sensitiveSet;

	char *avgRelErrorFilename = "error.txt";
	char *timeFilename = "time.txt";
	char *violateFilename = "violate.txt";

	int queryNoOfDim = conf->queryNoOfDim;
	double s = conf->s;
	int noOfCondition = conf->noOfCondition;

	int noOfViolation;

	double totalCred;

	//int noOfSenValueInSenAttr;

	float violateThreshold;
	int sampleThreshold;

	
	FILE *violateFilePtr;

#ifndef _WIN32
	FILE *filePtr;
	float  userTime, sysTime;
	float userTime_topDown, sysTime_topDown;
	struct rusage myTime1, myTime2, myTime_topDownEnd;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	noOfQID = conf->noOfDim-conf->noOfSenAttr;
	kAnonymity = conf->K;

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	g_debugFilePtr = debugFilePtr;

	//dimensionSetSet *readSensitiveSet(configure *conf)
	sensitiveSetSet = readSensitiveSet(conf);

	printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	//fprintf(debugFilePtr, "############## Summary ##################\n");
	//printf("############## Summary ##################\n");
	//printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	//isAlphaK = 1;

	senStartNo = conf->senStartNo;
	senEndNo = conf->senEndNo;

	// generate equivalence class from the data
	printf("Generating eq. class from Data....\n");
	proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 
	noOfValueInSenAttr = dataSet->dimSize[noOfQID];
	createSenValueInEqClass(proEqClass, dataSet, noOfValueInSenAttr);
	isAlphaK = isMech(proEqClass, conf, noOfValueInSenAttr);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// enforce alpha = 1/d
		conf->alpha = 1.0/conf->d;
		conf->K = 1;

		printf("Running top down approach ....\n");

		if (conf->alg == 11)
		{
			finalEqClass = fullSpace_KAlphaAnonymity(dataSet, conf, genAllTable, debugFilePtr);
		}
		else if (conf->alg == 30)
		{
			//equivalenceClass *topDownAlpha_KAlphaAnonymity(data *dataSet, configure *conf, generalizedAllTable *genAllTable, FILE *g_debugFilePtr)
			//finalEqClass = topDownAlpha_KAlphaAnonymity(dataSet, conf, genAllTable, debugFilePtr);

			finalEqClass = anatomy_main_output(dataSet, conf, genAllTable);
		}
		else if (conf->alg == 51)
		{
			finalEqClass = injector_main(dataSet, conf->d, conf);;
		}
		else if (conf->alg == 52)
		{
			printf(" Performing tlcosenesss....\n");
			finalEqClass = fullSpace_TCloseness(dataSet, conf, genAllTable, debugFilePtr);

			//
			createSenValueInEqClass(finalEqClass, dataSet, dataSet->dimSize[dataSet->noOfDim-1]);
		}
		else if (conf->alg == 53)
		{
			finalEqClass = mechDistortionMain(dataSet, conf, genAllTable);

			createSenValueInEqClass(finalEqClass, dataSet, dataSet->dimSize[dataSet->noOfDim-1]);
		}

		// transforming
		printf("Transforming ...\n");
		transformToBinaryData(conf, finalEqClass, dataSet);
		//noOfSenValue = 2;

		conf->senEndNo = 1;
		conf->senStartNo = 1;

		dataSet->dimSize[dataSet->noOfDim-1] = 2;

		createSenValueInEqClass(finalEqClass, dataSet, noOfValueInSenAttr);

		printf(" --------------- No. of Eq. Classes (in Injector) : %d -------\n", finalEqClass->noOfEqClass);
		// printing
		//fprintf(debugFilePtr, "############## proEqClass ##################\n");
		//printf("############## proEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		//printf("############## finalEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

#ifndef _WIN32

	getrusage(RUSAGE_SELF, &myTime_topDownEnd);	

	userTime =
     		((float) (myTime_topDownEnd.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime_topDownEnd.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime_topDownEnd.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime_topDownEnd.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;


	userTime_topDown = userTime;
	sysTime_topDown = sysTime;
#endif

		printf("Calculating violations...\n");
		violateThreshold = (float) (1.0/conf->d);

		sampleThreshold = calViolation_calculateSampleSize(conf->error, conf->sigma);
		//sampleThreshold = 1;
		printf(" Sample threshold = %d\n", sampleThreshold);
		

		violateFilePtr = (FILE *) fopen(violateFilename, "w");
		if (violateFilePtr == NULL)
		{
			printf("File %s cannot be opened!\n", violateFilename);
			exit(0);
		}
		calculateViolation(violateFilePtr, conf, dataSet, sampleThreshold, violateThreshold, finalEqClass);

		fclose(violateFilePtr);

	
		printf("Cacluting prob ....\n");
		//noOfSenValueInSenAttr = dataSet->dimSize[noOfQID];
		///probList = calculateCredibility(noOfSenValueInSenAttr, proEqClass, finalEqClass, noOfQID, conf->d, genAllTable);

		// calculate no. of violation
		noOfViolation = 0;
		totalCred = 0;
		for (i = 0; i < dataSet->noOfTuple; i++)
		{
			if (g_prob[i] > 1.0/conf->d)
			{
				noOfViolation++;
				totalCred += g_prob[i];
			}
		}

		fprintf(g_debugFilePtr, "%.10f\n", noOfViolation/((double) dataSet->noOfTuple));
		fprintf(g_debugFilePtr, "%.10f\n", totalCred/noOfViolation);
		fprintf(g_debugFilePtr, "%d\n", noOfViolation);
		fprintf(g_debugFilePtr, "%d\n", dataSet->noOfTuple);
		printf("prop of violations   : %.6f\n", noOfViolation/((double) dataSet->noOfTuple));
		printf("avg. credibility     : %.6f\n", totalCred/noOfViolation);
		printf("no of violations     : %d\n", noOfViolation);
		printf("total no. of tuples  : %d\n", dataSet->noOfTuple);
		for (i = 0; i < dataSet->noOfTuple; i++)
		{
			fprintf(g_debugFilePtr, "%.6f\n", g_prob[i]);
		}

  

	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);


	filePtr = (FILE *) fopen(timeFilename, "w");
	fprintf(filePtr, "%.6f\n",userTime);
    fprintf(filePtr, "%.6f\n\n",sysTime);
	fprintf(filePtr, "%.6f\n",userTime_topDown);
    fprintf(filePtr, "%.6f\n\n",sysTime_topDown);
	fclose(filePtr);
#endif

	fclose(debugFilePtr);
}



void test_calculateViolation()
{
	data *aData;
	int sampleThreshold;
	float violateThreshold;
	equivalenceClass *eqClass;

	configure *config;

	float error = 0.05f;
	float sigma = 1.0f;

	int noOfTuple = 6;//7;//8;
	int noOfEQTuple = 3;
	int noOfDim = 3;

	int i;

	int noOfSenValue;

	equivalenceTuple *eqTuple1;
	equivalenceTuple *eqTuple2;
	equivalenceTuple *eqTuple3;
	equivalenceTuple *eqTuple4;

	violateThreshold = 0.5f;

	sampleThreshold = calViolation_calculateSampleSize(error, sigma);
	sampleThreshold = 1;

	config = (configure *) malloc(sizeof(configure));
	config->senStartNo = 1;
	config->senEndNo = 1;

	aData = (data *) malloc(sizeof(data));

	aData->noOfDim = noOfDim;
	aData->dimSize = (int *) malloc(sizeof(int)*aData->noOfDim);
	aData->dimSize[0] = 2;
	aData->dimSize[1] = 2;
	aData->dimSize[2] = 2;

	noOfSenValue = aData->dimSize[1];

	aData->noOfTuple = noOfTuple;
	aData->tupleList = (tuple *) malloc(sizeof(tuple)*aData->noOfTuple);
	for (i = 0; i < noOfTuple; i++)
	{
		aData->tupleList[i].content = (dimension *) malloc(sizeof(dimension)*noOfDim);
		memset(aData->tupleList[i].content, 0, sizeof(dimension)*noOfDim);
	}
	aData->tupleList[0].content[0].value = 0;
	aData->tupleList[0].content[1].value = 0;
	aData->tupleList[0].content[2].value = 1;
	aData->tupleList[1].content[0].value = 1;
	aData->tupleList[1].content[1].value = 1;
	aData->tupleList[1].content[2].value = 0;
	aData->tupleList[2].content[0].value = 0;
	aData->tupleList[2].content[1].value = 0;
	aData->tupleList[2].content[2].value = 0;
	aData->tupleList[3].content[0].value = 0;
	aData->tupleList[3].content[1].value = 0;
	aData->tupleList[3].content[2].value = 1;
	aData->tupleList[4].content[0].value = 1;
	aData->tupleList[4].content[1].value = 1;
	aData->tupleList[4].content[2].value = 0;
	aData->tupleList[5].content[0].value = 1;
	aData->tupleList[5].content[1].value = 1;
	aData->tupleList[5].content[2].value = 0;
	//aData->tupleList[6].content[0].value = 1;
	//aData->tupleList[6].content[1].value = 0;
	//aData->tupleList[6].content[2].value = 0;
	//aData->tupleList[7].content[0].value = 1;
	//aData->tupleList[7].content[1].value = 0;
	//aData->tupleList[7].content[2].value = 0;

	eqClass = (equivalenceClass *) malloc(sizeof(equivalenceClass));

	eqClass->noOfEqClass = 4;//3;
	eqClass->eqClass = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*eqClass->noOfEqClass);

	eqTuple1 = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	eqTuple2 = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	eqTuple3 = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	eqTuple4 = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memset(eqTuple1, 0, sizeof(equivalenceTuple));
	memset(eqTuple2, 0, sizeof(equivalenceTuple));
	memset(eqTuple3, 0, sizeof(equivalenceTuple));
	memset(eqTuple4, 0, sizeof(equivalenceTuple));

	eqClass->eqClass[0] = eqTuple1;
	eqClass->eqClass[1] = eqTuple2;
	eqClass->eqClass[2] = eqTuple3;
	eqClass->eqClass[3] = eqTuple4;

	// eqTuple1
	eqTuple1->noOfMember = 2;//3;//4;
	eqTuple1->member = (int *) malloc(sizeof(int)*eqTuple1->noOfMember);
	eqTuple1->isSen = (int *) malloc(sizeof(int)*eqTuple1->noOfMember);
	eqTuple1->senValue = (dimension *) malloc(sizeof(dimension)*eqTuple1->noOfMember);
	memset(eqTuple1->senValue, 0, sizeof(dimension)*eqTuple1->noOfMember);
	eqTuple1->member[0] = 0;
	eqTuple1->member[1] = 1;
	//eqTuple1->member[2] = 6;
	//eqTuple1->member[3] = 7;
	eqTuple1->isSen[0] = 1;
	eqTuple1->isSen[1] = 0;
	//eqTuple1->isSen[2] = 0;
	//eqTuple1->isSen[3] = 0;
	eqTuple1->senValue[0].value = 1;
	eqTuple1->senValue[1].value = 0;
	//eqTuple1->senValue[2].value = 0;
	//eqTuple1->senValue[3].value = 0;

	eqTuple1->noOfEachSen = (int *) malloc(sizeof(int)*noOfSenValue);
	eqTuple1->noOfEachSen[0] = 1;
	eqTuple1->noOfEachSen[1] = 1;
	//eqTuple1->noOfEachSen[2] = 1;

	// eqTuple2
	eqTuple2->noOfMember = 2;
	eqTuple2->member = (int *) malloc(sizeof(int)*eqTuple2->noOfMember);
	eqTuple2->isSen = (int *) malloc(sizeof(int)*eqTuple2->noOfMember);
	eqTuple2->senValue = (dimension *) malloc(sizeof(dimension)*eqTuple2->noOfMember);
	memset(eqTuple2->senValue, 0, sizeof(dimension)*eqTuple2->noOfMember);
	eqTuple2->member[0] = 2;
	eqTuple2->member[1] = 3;
	eqTuple2->isSen[0] = 0;
	eqTuple2->isSen[1] = 1;
	eqTuple2->senValue[0].value = 0;
	eqTuple2->senValue[1].value = 1;

	eqTuple2->noOfEachSen = (int *) malloc(sizeof(int)*noOfSenValue);
	eqTuple2->noOfEachSen[0] = 1;
	eqTuple2->noOfEachSen[1] = 1;
	//eqTuple2->noOfEachSen[2] = 0;

	// eqTuple3
	eqTuple3->noOfMember = 1;//2;
	eqTuple3->member = (int *) malloc(sizeof(int)*eqTuple3->noOfMember);
	eqTuple3->isSen = (int *) malloc(sizeof(int)*eqTuple3->noOfMember);
	eqTuple3->senValue = (dimension *) malloc(sizeof(dimension)*eqTuple2->noOfMember);
	memset(eqTuple3->senValue, 0, sizeof(dimension)*eqTuple3->noOfMember);
	eqTuple3->member[0] = 4;
	//eqTuple3->member[1] = 5;
	eqTuple3->isSen[0] = 0;
	//eqTuple3->isSen[1] = 0;
	eqTuple3->senValue[0].value = 0;
	//eqTuple3->senValue[1].value = 0;

	eqTuple3->noOfEachSen = (int *) malloc(sizeof(int)*noOfSenValue);
	eqTuple3->noOfEachSen[0] = 1;//2;
	eqTuple3->noOfEachSen[1] = 0;
	//eqTuple3->noOfEachSen[2] = 0;

	// eqTuple4
	eqTuple3->noOfMember = 1;
	eqTuple3->member = (int *) malloc(sizeof(int)*eqTuple3->noOfMember);
	eqTuple3->isSen = (int *) malloc(sizeof(int)*eqTuple3->noOfMember);
	eqTuple3->senValue = (dimension *) malloc(sizeof(dimension)*eqTuple2->noOfMember);
	memset(eqTuple3->senValue, 0, sizeof(dimension)*eqTuple3->noOfMember);
	eqTuple3->member[0] = 5;
	//eqTuple3->member[1] = 5;
	eqTuple3->isSen[0] = 0;
	//eqTuple3->isSen[1] = 0;
	eqTuple3->senValue[0].value = 0;
	//eqTuple3->senValue[1].value = 0;

	eqTuple3->noOfEachSen = (int *) malloc(sizeof(int)*noOfSenValue);
	eqTuple3->noOfEachSen[0] = 1;
	eqTuple3->noOfEachSen[1] = 0;
	//eqTuple3->noOfEachSen[2] = 0;


	calculateViolation(stdout, config, aData, sampleThreshold, violateThreshold, eqClass);
}



int main314()
{
	//
	test_calculateViolation();

	return 0;
}
