/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A + B = AplsB                                                      */
/* -------------------------------------------------------------------------- */
void add_mR(
PmR A,
PmR B,
PmR AplsB)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */


  if (A->rows != B->rows || A->cols != B->cols)
    {
     printf("\n Error : add_mR(A,B,AplsB);\n");
     printf("\n matrices different sizes (A or B)\n");
     printf("\n Press return to continue.\n");
     //getchar();
     //exit(1);
    }

  if (A->rows!=AplsB->rows||A->cols!=AplsB->cols)
    {
     printf("\n Error : add_mR(A,B,AplsB);\n");
     printf("\n matrices different sizes (AplsB)\n");
     printf("\n Press return to continue.\n");
     //getchar();
     //exit(1);
    }

  for   ( r=0; r<A->rows; r++)
    for ( c=0; c<A->cols; c++)

 *(AplsB->pb+r *AplsB->cols+c) =   *(A->pb+r *A->cols+c)
                                 +
                                   *(B->pb+r *B->cols+c);
}
/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A - B = AmnsB                                                      */
/* -------------------------------------------------------------------------- */
void sub_mR(
PmR A,
PmR B,
PmR AmnsB)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */

  if (A->rows != B->rows || A->cols != B->cols)
    {
     printf("\n Error : sub_mR(A,B,AmnsB);\n");
     printf("\n matrices different sizes (A or B)\n");
     printf("\n Press return to continue.\n");
     //getchar();
     //exit(1);
    }

  if (A->rows!=AmnsB->rows||A->cols!=AmnsB->cols)
    {
     printf("\n Error : sub_mR(A,B,AmnsB);\n");
     printf("\n matrices different sizes (AmnsB)\n");
     printf("\n Press return to continue.\n");
     //getchar();
     //exit(1);
    }

  for   ( r=0; r<A->rows; r++)
    for ( c=0; c<A->cols; c++)

 *(AmnsB->pb+r *AmnsB->cols+c) =   *(A->pb+r *A->cols+c)
                                 -
                                   *(B->pb+r *B->cols+c);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A * B = AB                                                         */
/* -------------------------------------------------------------------------- */
void mul_mR(
PmR A,
PmR B,
PmR AB)
{
int i;
int j;
int k;

              for(k= 0; k < A->rows; k++)               /* Work on the rows k */

                  for(j=0; j<B->cols; j++)              /* Work on the cols j */
                   {
                    *(AB->pb+k *(AB->cols)+j) = 0;

                    for(i=0; i<A->cols; i++)            /* Compute AB(k,j)    */

                      *(AB->pb+k *(AB->cols)+j) +=   *(A->pb +k *(A->cols) +i)
                                                   *
                                                     *(B->pb +i *(B->cols) +j);
                   }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :  s * A = sA                                                      */
/* -------------------------------------------------------------------------- */
void smul_mR(
MAT_TYPE s,
PmR    A,
PmR   sA)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */

  for (   r=0; r<A->rows; r++)
    for ( c=0; c<A->cols; c++)

        (*(sA->pb+r *sA->cols+c)) = s * (*(A->pb+r *A->cols+c));

}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/* -------------------------------------------------------------------------- */
void transpose_mR(
PmR A,
PmR Trps_A)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */

  if (Trps_A->rows != A->cols)
    {
     printf("\n transpose_mR() error1\n");
     printf("\n destination matrix rows != source matrix cols\n");
     printf("\n Press return to continue\n");
     //getchar();
     //exit(1);
    }

  if (A->rows != Trps_A->cols)
    {
     printf("\n transpose() error2\n");
     printf("\n source matrix rows != destination matrix cols\n");
     printf("\n Press return to continue\n");
     //getchar();
     //exit(1);
    }

  for (   r=0; r<A->rows; r++)
    for ( c=0; c<A->cols; c++)

        *(Trps_A->pb+c *Trps_A->cols+r)  = *( A->pb+r *A->cols+c);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/* -------------------------------------------------------------------------- */
MAT_TYPE trace_mR(
PmR A)
{
int    i;
MAT_TYPE trace;

  if ((A->rows) !=  A->cols)
    {
     printf("\n trace_mR() error - Square matrix, please");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  trace = 0.0;

  for( i=0; i<A->rows; i++)

      trace += (*(A->pb+i *A->cols+i));

  return(trace);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : mA**n = mA_pn                                                       */
/* -------------------------------------------------------------------------- */
void pow_mR(
PmR  mA,
int     pn,
PmR  mA_pn
)
{
int  i;
mR  mT = {mA->rows,mA->cols,init_mR(mA->rows,mA->cols)};

 copy_mR(mA,mA_pn);

 if(!pn) eye_mR(mA_pn);
 else    for(i = pn-1 ; i ; i--)
            {
             mul_mR(mA_pn, mA,&mT);
             copy_mR(&mT,mA_pn);
            }
 free(mT.pb);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/* -------------------------------------------------------------------------- */
void HouseHolder_mR(
PmR a,
PmR Id
)
{
MAT_TYPE  s;

mR        a_T = {a->cols,a->rows,init_mR(a->cols,a->rows)};
mR       aa_T = {a->rows,a->rows,init_mR(a->rows,a->rows)};
mR      saa_T = {a->rows,a->rows,init_mR(a->rows,a->rows)};
mR Idmnssaa_T = {a->rows,a->rows,init_mR(a->rows,a->rows)};
mR       a_Ta = {      1,      1,init_mR(      1,      1)};

 eye_mR(Id);
 transpose_mR(a,&a_T);

 mul_mR(a,&a_T,&aa_T);
 mul_mR(&a_T,a,&a_Ta);

   s = (MAT_TYPE) (2. / (*(a_Ta.pb+0 *(a_Ta.cols)+0)) );

 smul_mR( s, &aa_T,     &saa_T);
  sub_mR(Id,&saa_T,&Idmnssaa_T);

 copy_mR(&Idmnssaa_T,Id);

 free(       a_T.pb);
 free(      aa_T.pb);
 free(     saa_T.pb);
 free(Idmnssaa_T.pb);
 free(      a_Ta.pb);
}

