/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : swap two rows in a matrix                                          */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void swap_r_R(
PmR m,
int     row1,
int     row2)
{
  int    j;
  MAT_TYPE t;

    for ( j=0 ; j<m->cols ; j++)
    {
                            t   = *(m->pb+row1 *m->cols+j);
      *(m->pb+row1 *m->cols+j ) = *(m->pb+row2 *m->cols+j);
      *(m->pb+row2 *m->cols+j ) =       t;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : returns a copy of the matrix m in which row is muliply by scalar   */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mul_r_R(
PmR    m,
int    rown,
MAT_TYPE f
)
{
 int  j;
//*** Ray modified
//MAT_TYPE fA;

 for( j=0; j<m->cols; j++)
  *(m->pb+rown *m->cols+j) = (*(m->pb+rown *m->cols+j)) * f;
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : returns a copy of the matrix m in which row r2 is                  */
/*         replaced  by (s*r1+r2)                                             */
/* -------------------------------------------------------------------------- */
void add_r_R(
PmR    m,
MAT_TYPE s,
int    row1,
int    row2

)
{
int      j;
MAT_TYPE sr1;
MAT_TYPE sr2;


 for ( j=0; j<m->cols; j++)
    {
     sr1  = *(m->pb+row1 *m->cols+j);
     sr2  = *(m->pb+row2 *m->cols+j);
     sr2 +=   s*sr1;

            *(m->pb+row2 *m->cols+j) = sr2;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : returns a copy of the matrix m in which row is muliply by scalar  */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void smul_r_R(
PmR m,
int rown,
MAT_TYPE f
)
{
   int  j;
MAT_TYPE fA;

 for( j=0 ; j<m->cols ; j++)
 {
  fA =  *(m->pb+rown *m->cols+j);
  fA = (fA*f);
        *(m->pb+rown *m->cols+j) = fA;
 }

}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : row1 =  row1 + row2                                                */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void r1_pls_r2_mR(
PmR  m,
int      row1,
int      row2
)
{
     int   j;
MAT_TYPE fr1;
MAT_TYPE fr2;


 for ( j = 0 ; j < m->cols ; j++)
    {
     fr1 = *(m->pb+row1 *m->cols+j  );
     fr2 = *(m->pb+row2 *m->cols+j  );

     fr2 =  (fr2+fr1);

     *(m->pb+row1 *m->cols+j  ) = fr2;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void add_r_mR(
PmR  u,
int  ru,
PmR  v,
int  rv,
PmR  w,
int  rw
)
{
   int  n;
MAT_TYPE un;
MAT_TYPE vn;
MAT_TYPE wn;


 for ( n=0 ; n<u->cols ; n++)
    {
     un = *(u->pb+ru *u->cols+n);
     vn = *(v->pb+rv *v->cols+n);

     wn =  (un+vn);

          *(w->pb+rw *w->cols+n) = wn;
    }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void sub_r_mR(
PmR  u,
int  ru,
PmR  v,
int  rv,
PmR  w,
int  rw
)
{
   int  n;
MAT_TYPE un;
MAT_TYPE vn;
MAT_TYPE wn;


 for ( n=0 ; n<u->cols ; n++)
    {
     un = *(u->pb+ru *u->cols+n);
     vn = *(v->pb+rv *v->cols+n);

     wn =  (un-vn);

          *(w->pb+rw *w->cols+n) = wn;
    }
}


