/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */
#include <math.h>
/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void    adjoint_mR(
PmR mCofactor,
PmR mAdjoint)
{
  if (mCofactor->rows != mAdjoint->rows || mCofactor-> cols != mAdjoint->cols)
    {
     printf("\n adjoint() error - matrices different sizes");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

 transpose_mR(mCofactor,mAdjoint);
}


int m_isContainValid(PmR mA)
{
	int i, j;
	int returnValue;

	int anIndex;

	MAT_TYPE aNo;

//+INF float: 7f800000
//-INF float: ff800000


//+NAN float: 7fc00000
//-NAN float: ffc00000

	float posInf, negInf;//, posNan, negNan;

	//posInf = 0x7f800000;
	//negInf = 0xff800000;
	//posNan = 0x7fc00000;
	//negNan = 0xffc00000;
	posInf = (float) 1e40;
	negInf = (float) -1e40;
	//posNan = 1.0/0.0;
	//negNan = -1.0/0.0;
	//posNan = 1.0;
	//negNan = -1.0;


	returnValue = 1;
	aNo = 0;

	for (i = 0; i < mA->rows; i++)
	{
		for (j = 0; j < mA->cols; j++)
		{
			anIndex = i*mA->rows+j;

			aNo = mA->pb[anIndex];

			if ((aNo == posInf) || (aNo == negInf))// || (aNo == posNan) || (aNo == negNan))
			{
				returnValue = 0;
				break;
			}
		}
		if ((aNo == posInf) || (aNo == negInf))// || (aNo == posNan) || (aNo == negNan))
		{
			break;
		}
	}
	
	return returnValue;
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
// 0: not successful
// 1: successful
int inverse_mR(
PmR  mA,
PmR  mInverse)
{
int    row;
MAT_TYPE f;
int isContainValid;

//MAT_TYPE pCofact[MXR][MXC];
//mR mCofact={MXR,MXC,&pCofact[0][0]};
mR mCofact;

               mCofact.rows=mCofact.cols=mA->rows;
			   mCofact.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mCofact.rows*mCofact.cols);

    //printf("--------------\n");
	//printf("mCofact\n");
	//p_mR(&mCofact);
	//printf("mInverse\n");
	//p_mR(mInverse);

     cofactor_mR(mA,&mCofact);
      adjoint_mR(   &mCofact,mInverse);

	  //printf("--------------\n");
	//printf("mCofact\n");
	  //p_mR(&mCofact);
	  //printf("mInverse\n");
	//p_mR(mInverse);

	 isContainValid = m_isContainValid(mInverse);

	 if (isContainValid == 0)
	 {
		 free(mCofact.pb);
		 return 0;
	 }

     if(!(det_R(mA)))
    {
     printf("\n inverse_mR error - A determinant is Zero\n");
     //printf("\n Press return to continue");
	 free(mCofact.pb);
	 return 0;
     //getchar();
     //exit(1);
    }

    f =  (MAT_TYPE) (1.) / (det_R(mA));
    for( row=0; row<mA->rows ; row++)
         mul_r_R(mInverse,row,f);

	free(mCofact.pb);

	return 1;
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inverse_diag_mR(
PmR mA,
PmR minvA
)
{
int i,j;

zeros_mR(minvA);

for (   i=0; i<mA->rows; i++)
  for ( j=0; j<mA->cols; j++)
      if((i==j) && (*(mA->pb+i *mA->cols+j)))
           *(minvA->pb+i *minvA->cols+j) =  (MAT_TYPE) (1./(*(mA->pb+i *mA->cols+j)));
}




/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inv_diag_mR(
PmR mA,
PmR minvA,
MAT_TYPE e)
{
MAT_TYPE z;
int i;
int j;

  zeros_mR(minvA);

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j++)
       {

       if( i==j)
         {
          z = (*(mA->pb+i *mA->cols+j));

          if( (z<e) ) (*(minvA->pb+i *minvA->cols+j)) = 0;
          else        (*(minvA->pb+i *minvA->cols+j)) = 1/z;

         }

       }
}

