/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_uDotv_uv(
PmR mu,
PmR mv
)
{
MAT_TYPE InnerProduct;
//MAT_TYPE pbuv [MXR][MXC];
//mR muv ={MXR,MXC,&pbuv [0][0]};
mR muv;

                 muv.rows =1;    muv.cols =1;
				 muv.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*1*1);

  if (mu->rows != 1 ||
      mu->cols != mv->rows ||
      mv->cols != 1
     )
    {
     printf(" uDotv_uv() error.\n\n");

     printf(" u.rows = 1\n");
     printf(" u.cols = v.rows\n");
     printf(" v.cols = 1\n");

     printf("\nPress Return to continue\n");
     //getchar();
     //exit(1);
    }

  mul_mR(mu,mv,&muv);

  InnerProduct = *(muv.pb+0 *muv.cols+0  );

  free(muv.pb);

  return(InnerProduct);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_uDotv_uvT(
PmR mu,
PmR mv
)
{
MAT_TYPE InnerProduct             ;
int      n           =  mu->cols;

//MAT_TYPE pbvT   [MXR][MXC];
//mR mvT   ={MXR,MXC,&pbvT   [0][0]};
mR mvT;
//MAT_TYPE pbuvT  [MXR][MXC];
//mR muvT  ={MXR,MXC,&pbuvT  [0][0]};
mR muvT;

                 mvT.rows =n;       mvT.cols =  1;
                muvT.rows =1;      muvT.cols =  1;

				mvT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvT.rows*mvT.cols);
				muvT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*muvT.rows*muvT.cols);

  if (mu->rows != mv->rows ||
      mu->cols != mv->cols ||
      mu->rows != 1
     )
    {
     printf(" uDotv_uvT() error.\n\n");

     printf(" u.rows = v.rows\n");
     printf(" u.cols = v.cols\n");
     printf(" u.rows = 1\n");

     printf("\nPress Return to continue\n");
     //getchar();
     //exit(1);
    }

  transpose_mR(mv,&mvT);

  mul_mR(mu,&mvT,&muvT);

  InnerProduct = *(muvT.pb+0 *muvT.cols+0  );

  free(mvT.pb);
  free(muvT.pb);

  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_uDotv_vTu(
PmR mu,
PmR mv
)
{
MAT_TYPE InnerProduct             ;
int      n           =  mu->rows;

//MAT_TYPE pbvT   [MXR][MXC];
//mR mvT   ={MXR,MXC,&pbvT   [0][0]};
//MAT_TYPE pbvT_u [MXR][MXC];
//mR mvT_u ={MXR,MXC,&pbvT_u [0][0]};
mR mvT;
mR mvT_u;

                  mvT.rows =1;      mvT.cols =n;
                mvT_u.rows =1;    mvT_u.cols =1;

				mvT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvT.rows*mvT.cols);
				mvT_u.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvT_u.rows*mvT_u.cols);

  if (mu->rows != mv->rows ||
      mu->cols != mv->cols ||
      mu->cols != 1
     )
    {
     printf(" uDotv_vTu() error.\n\n");

     printf(" u.rows = v.rows\n");
     printf(" u.cols = v.cols\n");
     printf(" u.cols = 1\n");

     printf("\nPress Return to continue\n");
     //getchar();
     //exit(1);
    }

  transpose_mR(mv,&mvT);

  mul_mR(&mvT,mu,&mvT_u);

  InnerProduct = *(mvT_u.pb+0 *mvT_u.cols+0  );

  free(mvT.pb);
  free(mvT_u.pb);

  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_uDotv_vu(
PmR mu,
PmR mv
)
{
MAT_TYPE InnerProduct             ;

//MAT_TYPE pbvu [MXR][MXC];
//mR mvu ={MXR,MXC,&pbvu [0][0]};
mR mvu;

                mvu.rows =1;    mvu.cols =1;
				mvu.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvu.rows*mvu.cols);

  if (mu->rows * 1 != mv->cols ||
      mu->cols          != 1   ||
      mv->rows          != 1
     )
    {
     printf(" uDotv_vu() error.\n\n");

     printf(" u.rows = v.cols\n");
     printf(" u.cols = 1\n");
     printf(" v.rows = 1\n");

     printf("\nPress Return to continue\n");
     //getchar();
     //exit(1);
    }

  mul_mR(mv,mu,&mvu);

  InnerProduct = *(mvu.pb+0 *mvu.cols+0  );

  free(mvu.pb);

  return(InnerProduct);
}

