/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void lu_mOR(
PmR  mA,
PmR  mL,
PmR  mU,
PmR  mP
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[l,u,p]=lu(a);    \n\n");
  fprintf(fp,"ow_mr(l,\"al.dat\");\n");
  fprintf(fp,"ow_mr(u,\"au.dat\");\n");
  fprintf(fp,"ow_mr(p,\"ap.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mL,"al.dat");
  read_mR(mU,"au.dat");
  read_mR(mP,"ap.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void chol_mOR(
PmR  mA,
PmR  mG_T
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"G_T=chol(a);          \n\n");
  fprintf(fp,"ow_mr(G_T,\"ag_t.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mG_T,"ag_t.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void hess_mOR(
PmR  mA,
PmR  mP,
PmR  mH
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[p, h]=hess (a);  \n\n");
  fprintf(fp,"ow_mr(p,\"ap.dat\");\n");
  fprintf(fp,"ow_mr(h,\"ah.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mP,"ap.dat");
  read_mR(mH,"ah.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void qr_mOR(
PmR  mA,
PmR  Q,
PmR  R
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[q, r] = qr (a);  \n\n");
  fprintf(fp,"ow_mr(q,\"aq.dat\");\n");
  fprintf(fp,"ow_mr(r,\"ar.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(Q,"aq.dat");
  read_mR(R,"ar.dat");
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void svd_mOR(
PmR  mA,
PmR  mU,
PmR  mS,
PmR  mV
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[u,s,v]=svd(a);   \n\n");
  fprintf(fp,"ow_mr(u,\"au.dat\");\n");
  fprintf(fp,"ow_mr(s,\"as.dat\");\n");
  fprintf(fp,"ow_mr(v,\"av.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mU,"au.dat");
  read_mR(mS,"as.dat");
  read_mR(mV,"av.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void eig_mOR(
PmR  mA,
PmR  mEVe,
PmR  mEVa
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[eve,eva]=eig(a);\n\n");
  fprintf(fp,"ow_mr(eve,\"aeve.dat\");\n");
  fprintf(fp,"ow_mr(eva,\"aeva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mEVe,"aeve.dat");
  read_mR(mEVa,"aeva.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void schur_mOR(
PmR  mA,
PmR  mU,
PmR  mS
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[U, S]=schur(a);  \n\n");
  fprintf(fp,"ow_mr(U,\"au.dat\");\n");
  fprintf(fp,"ow_mr(S,\"as.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mU,"au.dat");
  read_mR(mS,"as.dat");
}
