/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A + B = AplsB                                                   */
/* -------------------------------------------------------------------------- */
void add_mZ(
PmZ A,
PmZ B,
PmZ AplsB)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */

complexZ     a;
complexZ     b;
complexZ aplsb;

  if (A->rows != B->rows || A->cols != B->cols)
    {
     printf("\n Error : add_mZ(A,B,AplsB);\n");
     printf("\n matrices different sizes (A or B)\n");
     printf("\n Press return to continue.\n");
     getchar();
     exit(1);
    }

  if (A->rows!=AplsB->rows||A->cols!=AplsB->cols)
    {
     printf("\n Error : add_mZ(A,B,AplsB);\n");
     printf("\n matrices different sizes (AplsB)\n");
     printf("\n Press return to continue.\n");
     getchar();
     exit(1);
    }

  for (   r=0; r<A->rows; r++  )
    for ( c=0; c<A->cols; c+=C2)
         {
          a.r = *(A->pb+r *A->cols+c   );
          a.i = *(A->pb+r *A->cols+c+C1);

          b.r = *(B->pb+r *B->cols+c   );
          b.i = *(B->pb+r *B->cols+c+C1);

          aplsb = add_Z(a, b);

          *(AplsB->pb+r *AplsB->cols+c   )   = aplsb.r;
          *(AplsB->pb+r *AplsB->cols+c+C1)   = aplsb.i;
         }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A - B = AmnsB                                                   */
/* -------------------------------------------------------------------------- */
void sub_mZ(
PmZ A,
PmZ B,
PmZ AmnsB)
{
int r;                                                           /* (r)ow     */
int c;                                                           /* (c)column */

complexZ     a;
complexZ     b;
complexZ amnsb;

  if (A->rows != B->rows || A->cols != B->cols)
    {
     printf("\n Error : sub_mZ(A,B,AmnsB);\n");
     printf("\n matrices different sizes (A or B)\n");
     printf("\n Press return to continue.\n");
     getchar();
     exit(1);
    }

  if (A->rows!=AmnsB->rows||A->cols!=AmnsB->cols)
    {
     printf("\n Error : sub_mZ(A,B,AmnsB);\n");
     printf("\n matrices different sizes (AmnsB)\n");
     printf("\n Press return to continue.\n");
     getchar();
     exit(1);
    }

  for (   r=0; r<A->rows; r++  )
    for ( c=0; c<A->cols; c+=C2)
         {
          a.r = *(A->pb+r *A->cols+c   );
          a.i = *(A->pb+r *A->cols+c+C1);

          b.r = *(B->pb+r *B->cols+c   );
          b.i = *(B->pb+r *B->cols+c+C1);

          amnsb = sub_Z(a, b);

          *(AmnsB->pb+r *AmnsB->cols+c   )   = amnsb.r;
          *(AmnsB->pb+r *AmnsB->cols+c+C1)   = amnsb.i;
         }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : A * B = AB                                                         */
/* -------------------------------------------------------------------------- */
void mul_mZ(
PmZ A,
PmZ B,
PmZ AB)
{
int i;
int j;
int k;
complexZ a;
complexZ b;
complexZ ab;
complexZ abplsab;

    for( k = 0; k < A->rows ; k++)                      /* Work on the rows k */

     for( j = 0; j < B->cols ; j += C2)                 /* Work on the cols j */
     {
      abplsab = init_Z(0,0);
      for( i = 0; i < A->cols ; i += C2)                /* Compute AB(k,j)    */
         {
          a.r = *(A->pb+k *A->cols+i  );
          a.i = *(A->pb+k *A->cols+i+C1);

          b.r = *(B->pb+(i/C2) *B->cols+j   );
          b.i = *(B->pb+(i/C2) *B->cols+j+C1);

          ab = mul_Z(a,b);

          abplsab = add_Z(abplsab,ab);
         }
         *(AB->pb+k *AB->cols+j   ) = abplsab.r;
         *(AB->pb+k *AB->cols+j+C1) = abplsab.i;
     }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : mA**n = mAPn                                                       */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void pow_mZ(
PmZ mA,
int     Pn,
PmZ mAPn
)
{
 int i;

//MAT_TYPE pbT[MXR][MXC*C2];
//mZ mT ={MXR,MXC*C2,&pbT[0][0]};
 mZ mT;

            mT.rows = mA->rows;
            mT.cols = mA->rows*C2;

			mT.pB  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT.rows*mT.cols);

 copy_mZ(mA,mAPn);

 if(!Pn) eye_mZ(mAPn);
 else    for(i = Pn-1 ; i ; i--)
            {
             mul_mZ(mAPn,mA,&mT);
             copy_mZ(&mT,mAPn);
            }

 free(mT.pB);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void smul_mZ(
MAT_TYPE s,
PmZ  mA,
PmZ  mfA)
{
     int i;
     int j;
complexZ z;

  for (   i = 0; i < mA->rows ; i++)
    for ( j = 0; j < mA->cols ; j += C2)
         {
          z.r = *(mA->pb+i *mA->cols+j   );
          z.i = *(mA->pb+i *mA->cols+j+C1);

          z = smul_Z(s,z);

          *(mfA->pb+i *mfA->cols+j   ) = z.r;
          *(mfA->pb+i *mfA->cols+j+C1) = z.i;
         }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void zmul_mZ(
complexZ za,
PmZ  mA,
PmZ  mfA)
{
     int i;
     int j;
complexZ z1;
complexZ z2;

  for (   i = 0; i < mA->rows ; i++)
    for ( j = 0; j < mA->cols ; j += C2)
         {
          z1.r = *(mA->pb+i *mA->cols+j   );
          z1.i = *(mA->pb+i *mA->cols+j+C1);

          z2 = mul_Z(za,z1);

          *(mfA->pb+i *mfA->cols+j   ) = z2.r;
          *(mfA->pb+i *mfA->cols+j+C1) = z2.i;
         }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void c_mZ(
PmZ mA,
PmZ mConjA)
{
     int i;
     int j;
complexZ z;

  for (   i = 0; i < mA->rows ; i++)
    for ( j = 0; j < mA->cols ; j += C2)
         {
          z.r = *(mA->pb+i *mA->cols+j  );
          z.i = *(mA->pb+i *mA->cols+j+C1);

          z = c_Z(z);

                  *(mConjA->pb+i *mConjA->cols+j   ) = z.r;
                  *(mConjA->pb+i *mConjA->cols+j+C1) = z.i;
         }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void ctranspose_mZ(
PmZ mA,
PmZ mTrpsA)
{
     int i;
     int j;
complexZ z;

  if (mTrpsA->rows * C2 != mA->cols)
    {
     printf("\n transpose() error - dest matrix rows must = source matrix cols");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }
  if (mA->rows * C2 != mTrpsA->cols)
    {
     printf("\n transpose() error - source matrix rows must = dest matrix cols");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

  for (   i = 0; i < mA->rows ; i++)
    for ( j = 0; j < mA->cols ; j += C2)
         {
          z.r = *(mA->pb+i *mA->cols+j   );
          z.i = *(mA->pb+i *mA->cols+j+C1);

          z = c_Z(z);

          *(mTrpsA->pb+j/C2 *mTrpsA->cols+i*C2   )   = z.r;
          *(mTrpsA->pb+j/C2 *mTrpsA->cols+i*C2+C1)   = z.i;
         }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void transpose_mZ(
PmZ mA,
PmZ mTrpsA)
{
     int i;
     int j;
complexZ z;

  if (mTrpsA->rows * C2 != mA->cols)
    {
     printf("\n transpose() error - dest matrix rows must = source matrix cols");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }
  if (mA->rows * C2 != mTrpsA->cols)
    {
     printf("\n transpose() error - source matrix rows must = dest matrix cols");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

  for (   i = 0; i < mA->rows ; i++)
    for ( j = 0; j < mA->cols ; j += C2)
         {
          z.r = *(mA->pb+i *mA->cols+j   );
          z.i = *(mA->pb+i *mA->cols+j+C1);

          *(mTrpsA->pb+j/C2 *mTrpsA->cols+i*C2   )   = z.r;
          *(mTrpsA->pb+j/C2 *mTrpsA->cols+i*C2+C1)   = z.i;
         }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ trace_mZ(
PmZ m)
{
     int i;
complexZ Trace;
complexZ zT;

  if ((m->rows * C2) !=  m->cols)
    {
     printf("\n trF() error - Square mF, please");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

    Trace = init_Z(0,0);

  for(   i = 0; i < m->rows ; i++)
     {
      zT.r = (*(m->pb+i *m->cols+i*C2   ));
      zT.i = (*(m->pb+i *m->cols+i*C2+C1));

           Trace  = add_Z(Trace,zT);
     }

  return(Trace);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void HouseHolder_mZ(
PmZ a,
PmZ Id
)
{
complexZ    s;
complexZ    z;
complexZ  two;

mZ        a_T = {a->cols/C2,a->rows*C2,init_mZ(a->cols/C2,a->rows*C2)};
mZ       aa_T = {a->rows,   a->rows*C2,init_mZ(a->rows,   a->rows*C2)};
mZ      saa_T = {a->rows,   a->rows*C2,init_mZ(a->rows,   a->rows*C2)};
mZ Idmnssaa_T = {a->rows,   a->rows*C2,init_mZ(a->rows,   a->rows*C2)};
mZ       a_Ta = {      1,         1*C2,init_mZ(      1,         1*C2)};

 eye_mZ(Id);
 ctranspose_mZ(a,&a_T);

 mul_mZ(a,&a_T,&aa_T);
 mul_mZ(&a_T,a,&a_Ta);

  two = init_Z(2, 0);
    z = init_Z((*(a_Ta.pb+0 *(a_Ta.cols)+0 )),
                (*(a_Ta.pb+0 *(a_Ta.cols)+C1)));
    s = div_Z(two,z);

 zmul_mZ( s, &aa_T,     &saa_T);
  sub_mZ(Id,&saa_T,&Idmnssaa_T);

 copy_mZ(&Idmnssaa_T,Id);

 free(       a_T.pb);
 free(      aa_T.pb);
 free(     saa_T.pb);
 free(Idmnssaa_T.pb);
 free(      a_Ta.pb);
}

