/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ c_Z(complexZ z)
{
complexZ zt;

        zt.r =      z.r;
        zt.i =  (-1*z.i);

return (zt);
}
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ sym_Z(complexZ z)
{
complexZ zt;

        zt.r =  (-1*z.r);
        zt.i =  (-1*z.i);

return (zt);
}
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ add_Z(complexZ z1, complexZ z2)
{
complexZ zt;

       zt.r = (z1.r+z2.r);
       zt.i = (z1.i+z2.i);

return (zt);
}
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ sub_Z(complexZ z1, complexZ z2)
{
complexZ zt;

        zt.r = (z1.r-z2.r);
        zt.i = (z1.i-z2.i);

return (zt);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ mul_Z(complexZ z1, complexZ z2)
{
complexZ  zt;

        zt.r = (( z1.r*z2.r)-( z1.i*z2.i));
        zt.i = (( z1.i*z2.r)+( z1.r*z2.i));

return (zt);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ smul_Z(MAT_TYPE s, complexZ z)
{
complexZ  zt;

         zt.r = (z.r*s);
         zt.i = (z.i*s);

return (zt);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE abs_P2_Z(complexZ z)
{
complexZ    zt;
complexZ c_z;

     c_z = c_Z(z);
        zt = mul_Z(z,c_z);

	return (zt.r);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ div_Z(complexZ z1, complexZ z2)
{
complexZ         zt;
complexZ     c_z2;

      c_z2 = c_Z(z2);
          zt = mul_Z(z1,c_z2);

  if ( !((abs_P2_Z(z2))) )
    {
     printf("\n div_Z() error - 1/0");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

       zt.r = (zt.r* (1/(abs_P2_Z(z2))));
       zt.i = (zt.i* (1/(abs_P2_Z(z2))));

	return (zt);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ inv_Z(complexZ z)
{
complexZ       zt;
complexZ     c_z;

     c_z =  c_Z(z);

  if ( !(abs_P2_Z(z)) )
    {
     printf("\n div_Z() error - 1/0");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

       zt.r = (c_z.r* (1/(abs_P2_Z(z))));
       zt.i = (c_z.i* (1/(abs_P2_Z(z))));

	return (zt);
}
