/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : swap two rows in a matrix                                          */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void swap_r_Z(
PmZ m,
int     row1,
int     row2)
{
int    j;
MAT_TYPE t;

    for ( j = 0 ; j < m->cols ; j++)
    {
                            t   = *(m->pb+row1 *m->cols+j);
      *(m->pb+row1 *m->cols+j ) = *(m->pb+row2 *m->cols+j);
      *(m->pb+row2 *m->cols+j ) =   t;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mul_r_Z(
PmZ  mA,
int      row,
complexZ z)
{
     int j;
complexZ za;

    for ( j = 0; j < mA->cols ; j += C2)
         {
          za.r = *(mA->pb+row *mA->cols+j   );
          za.i = *(mA->pb+row *mA->cols+j+C1);

          za = mul_Z(za,z);

          *(mA->pb+row *mA->cols+j   ) = za.r;
          *(mA->pb+row *mA->cols+j+C1) = za.i;
         }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void add_r_Z(
PmZ  mA,
complexZ z,
int      row1,
int      row2)
{
     int j;
complexZ zrow1;
complexZ zrow2;

    for( j = 0; j < mA->cols ; j += C2)
        {
        zrow1.r = *(mA->pb+row1 *mA->cols+j   );
        zrow1.i = *(mA->pb+row1 *mA->cols+j+C1);

        zrow1 = mul_Z(zrow1,z);

        zrow2.r = *(mA->pb+row2 *mA->cols+j   );
        zrow2.i = *(mA->pb+row2 *mA->cols+j+C1);

        zrow2 = add_Z(zrow1,zrow2);

        *(mA->pb+row2 *mA->cols+j   ) = zrow2.r;
        *(mA->pb+row2 *mA->cols+j+C1) = zrow2.i;
        }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : mA + mB = mAplsB                                                   */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void add_r_mZ(
PmZ mu,
int  ru,
PmZ mv,
int  rv,
PmZ mw,
int  rw
)
{
     int j;
complexZ zu;
complexZ zv;
complexZ zw;

    for ( j = 0; j < mu->cols ; j += C2)
         {
          zu.r = *(mu->pb+ru *mu->cols+j   );
          zu.i = *(mu->pb+ru *mu->cols+j+C1);

          zv.r = *(mv->pb+rv *mv->cols+j   );
          zv.i = *(mv->pb+rv *mv->cols+j+C1);

          zw = add_Z(zu, zv);

          *(mw->pb+rw *mw->cols+j   )   = zw.r;
          *(mw->pb+rw *mw->cols+j+C1)   = zw.i;
         }
}
/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : mu + mv = mumnsv                                                   */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void sub_r_mZ(
PmZ mu,
int  ru,
PmZ mv,
int  rv,
PmZ mw,
int  rw
)
{
     int j;
complexZ zu;
complexZ zv;
complexZ zw;


    for ( j = 0; j < mu->cols ; j += C2)
         {
          zu.r = *(mu->pb+ru *mu->cols+j   );
          zu.i = *(mu->pb+ru *mu->cols+j+C1);

          zv.r = *(mv->pb+rv *mv->cols+j   );
          zv.i = *(mv->pb+rv *mv->cols+j+C1);

          zw = sub_Z(zu, zv);

          *(mw->pb+rw *mw->cols+j   )   = zw.r;
          *(mw->pb+rw *mw->cols+j+C1)   = zw.i;
         }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : row1 =  row1 + row2                                                */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void r1_pls_r2_mZ(
PmZ  m,
int      row1,
int      row2
)
{
     int   j;
complexZ fr1;
complexZ fr2;


 for ( j=0; j<m->cols; j+=C2)
    {
     fr1.r = *(m->pb+row1 *m->cols+j+0);     fr1.i = *(m->pb+row1 *m->cols+j+1);
     fr2.r = *(m->pb+row2 *m->cols+j+0);     fr2.i = *(m->pb+row2 *m->cols+j+1);

     fr2 = add_Z(fr2,fr1);

     *(m->pb+row1 *m->cols+j+0) = fr2.r;     *(m->pb+row1 *m->cols+j+1) = fr2.i;
    }
}

