/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void lu_mOZ(
PmZ  mA,
PmZ  mL,
PmZ  mU,
PmZ  mP
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[l,u,p]=lu(a);    \n\n");
  fprintf(fp,"ow_mz(l,\"al.dat\");\n");
  fprintf(fp,"ow_mz(u,\"au.dat\");\n");
  fprintf(fp,"ow_mz(p,\"ap.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mL,"al.dat");
  read_mZ(mU,"au.dat");
  read_mZ(mP,"ap.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void hess_mOZ(
PmZ  mA,
PmZ  mP,
PmZ  mH
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[p, h]=hess (a);  \n\n");
  fprintf(fp,"ow_mz(p,\"ap.dat\");\n");
  fprintf(fp,"ow_mz(h,\"ah.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mP,"ap.dat");
  read_mZ(mH,"ah.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void qr_mOZ(
PmZ  mA,
PmZ  Q,
PmZ  R
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[q, r] = qr (a);  \n\n");
  fprintf(fp,"ow_mz(q,\"aq.dat\");\n");
  fprintf(fp,"ow_mz(r,\"ar.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(Q,"aq.dat");
  read_mZ(R,"ar.dat");
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void svd_mOZ(
PmZ  mA,
PmZ  mU,
PmZ  mS,
PmZ  mV
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[U,S,V]=svd(a);   \n\n");
  fprintf(fp,"ow_mz(U,\"au.dat\");\n");
  fprintf(fp,"ow_mz(S,\"as.dat\");\n");
  fprintf(fp,"ow_mz(V,\"av.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mU,"au.dat");
  read_mZ(mS,"as.dat");
  read_mZ(mV,"av.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void eig_mOZ(
PmZ  mA,
PmZ  mEVe,
PmZ  mEVa
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[eve,eva]=eig(a);\n\n");
  fprintf(fp,"ow_mz(eve,\"aeve.dat\");\n");
  fprintf(fp,"ow_mz(eva,\"aeva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mEVe,"aeve.dat");
  read_mZ(mEVa,"aeva.dat");
}



/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void schur_mOZ(
PmZ  mA,
PmZ  mU,
PmZ  mS
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
     fprintf(fp," %+1.5f%+.5f*i",
                              *(mA->pb+i *mA->cols+j   ),
                              *(mA->pb+i *mA->cols+j+C1) );
      if(j<(mA->cols-C2))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"[U,S]=schur(a);   \n\n");
  fprintf(fp,"ow_mz(U,\"au.dat\");\n");
  fprintf(fp,"ow_mz(S,\"as.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  getchar();

  read_mZ(mU,"au.dat");
  read_mZ(mS,"as.dat");
}
