/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ uv_uv_Z(
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

MAT_TYPE pbCnjv [MXR][MXC*C2];mZ mCnjv ={MXR,MXC*C2,&pbCnjv [0][0]};
MAT_TYPE pbuCnjv[MXR][MXC*C2];mZ muCnjv={MXR,MXC*C2,&pbuCnjv[0][0]};

              mCnjv.rows = mv->rows;  mCnjv.cols = mv->cols;
             muCnjv.rows =        1; muCnjv.cols =       C2;

  if (mu->rows != 1             ||
      mu->cols != mv->rows * C2 ||
      mv->cols != C2
     )
    {
     printf(" uv_uCnjv() error.\n\n");

     printf(" u.rows = 1\n");
     printf(" u.cols = v.rows\n");
     printf(" v.cols = 1\n");

     printf("\nPress Return to continue\n");
     getchar();
     exit(1);
    }

  c_mZ(mv,&mCnjv);
  mul_mZ(mu,&mCnjv,&muCnjv);

  InnerProduct.r = *(muCnjv.pb+0 *muCnjv.cols   );
  InnerProduct.i = *(muCnjv.pb+0 *muCnjv.cols+C1);

  return(InnerProduct);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ uv_uvT_Z(
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

MAT_TYPE pbTrpsv [MXR][MXC*C2];mZ mTrpsv  = {MXR,MXC*C2,&pbTrpsv [0][0]};
MAT_TYPE pbuTrpsv[MXR][MXC*C2];mZ muTrpsv = {MXR,MXC*C2,&pbuTrpsv[0][0]};

                 mTrpsv.rows =mu->cols / C2;       mTrpsv.cols =  C2;
                muTrpsv.rows =1;                  muTrpsv.cols =  C2;

  if (mu->rows != mv->rows ||
      mu->cols != mv->cols ||
      mu->rows != 1
     )
    {
     printf(" uv_uvT() error.\n\n");

     printf(" u.rows = v.rows\n");
     printf(" u.cols = v.cols\n");
     printf(" u.rows = 1\n");

     printf("\nPress Return to continue\n");
     getchar();
     exit(1);
    }

  ctranspose_mZ(mv,&mTrpsv);

  mul_mZ(mu,&mTrpsv,&muTrpsv);

  InnerProduct.r = *(muTrpsv.pb+0 *muTrpsv.cols   );
  InnerProduct.i = *(muTrpsv.pb+0 *muTrpsv.cols+C1);

  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ uv_uTv_Z(
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

MAT_TYPE pbTrpsu[MXR][MXC*C2];mZ mTrpsu ={MXR,MXC*C2,&pbTrpsu[0][0]};
MAT_TYPE pbCnjv [MXR][MXC*C2];mZ mCnjv  ={MXR,MXC*C2,&pbCnjv [0][0]};
MAT_TYPE pbTrpsu_Cnjv  [MXR][MXC*C2];mZ  mTrpsu_Cnjv ={MXR,MXC*C2,&pbTrpsu_Cnjv[0][0]};

             mTrpsu.rows = 1;                  mTrpsu.cols = mu->rows*C2;
              mCnjv.rows =  mv->rows ;          mCnjv.cols = 1*C2;
        mTrpsu_Cnjv.rows = 1;             mTrpsu_Cnjv.cols = 1*C2;


  if (mu->rows != mv->rows ||
      mu->cols != mv->cols ||
      mu->cols != C2
     )
    {
     printf(" uv_vTu() error.\n\n");

     printf(" u.rows = v.rows\n");
     printf(" u.cols = v.cols\n");
     printf(" u.cols = 1\n");

     printf("\nPress Return to continue\n");
     getchar();
     exit(1);
    }

  transpose_mZ(mu,&mTrpsu);

  c_mZ(mv,&mCnjv);
  mul_mZ(&mTrpsu,&mCnjv,&mTrpsu_Cnjv);

  InnerProduct.r = *(mTrpsu_Cnjv.pb+0 *mTrpsu_Cnjv.cols   );
  InnerProduct.i = *(mTrpsu_Cnjv.pb+0 *mTrpsu_Cnjv.cols+C1);

  return(InnerProduct);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ uv_uTvT_Z(
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

MAT_TYPE pbTrpsu   [MXR][MXC*C2];mZ mTrpsu    ={MXR,MXC*C2,&pbTrpsu   [0][0]};
MAT_TYPE pbTrpsv   [MXR][MXC*C2];mZ mTrpsv    ={MXR,MXC*C2,&pbTrpsv   [0][0]};
MAT_TYPE pbTrpsu_Trpsv[MXR][MXC*C2];mZ  mTrpsu_Trpsv ={MXR,MXC*C2,&pbTrpsu_Trpsv[0][0]};

                 mTrpsu.rows = 1;                   mTrpsu.cols = mu->rows*C2;
                 mTrpsv.rows =mv->cols / C2;        mTrpsv.cols = 1*C2;
           mTrpsu_Trpsv.rows = 1;             mTrpsu_Trpsv.cols = 1*C2;

  if (mu->rows * C2 != mv->cols ||
      mu->cols          != C2   ||
      mv->rows          != 1
     )
    {
     printf(" uv_vu() error.\n\n");

     printf(" u.rows = v.cols\n");
     printf(" u.cols = 1\n");
     printf(" v.rows = 1\n");

     printf("\nPress Return to continue\n");
     getchar();
     exit(1);
    }

   transpose_mZ( mu,     &mTrpsu);
  ctranspose_mZ( mv,     &mTrpsv);
        mul_mZ( &mTrpsu,&mTrpsv, &mTrpsu_Trpsv);

  InnerProduct.r = *(mTrpsu_Trpsv.pb+0 *mTrpsu_Trpsv.cols   );
  InnerProduct.i = *(mTrpsu_Trpsv.pb+0 *mTrpsu_Trpsv.cols+C1);

  return(InnerProduct);
}

