/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ innerprod_w_Z(
PmZ mD,
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

//MAT_TYPE pbuD     [MXR][MXC*C2];
//mZ muD      = {MXR,MXC*C2,&pbuD     [0][0]};
//MAT_TYPE pbT_D    [MXR][MXC*C2];
//mZ mT_D     = {MXR,MXC*C2,&pbT_D    [0][0]};
//MAT_TYPE pbTrpsv  [MXR][MXC*C2];
//mZ mTrpsv   = {MXR,MXC*C2,&pbTrpsv  [0][0]};
//MAT_TYPE pbuDTrpsv[MXR][MXC*C2];
//mZ muDTrpsv = {MXR,MXC*C2,&pbuDTrpsv[0][0]};

mZ muD;
mZ mT_D;
mZ mTrpsv;
mZ muDTrpsv;


                   muD.rows  =mu->rows;               muD.cols = C2;
                   mT_D.rows =mu->rows;              mT_D.cols = mu->rows*C2;
                 mTrpsv.rows =mu->cols / C2;       mTrpsv.cols = C2;
               muDTrpsv.rows =1;                 muDTrpsv.cols = C2;

			   muD.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*muD.rows*muD.cols);
			   mT_D.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT_D.rows*mT_D.cols);
			   mTrpsv.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mTrpsv.rows*mTrpsv.cols);
			   muDTrpsv.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*muDTrpsv.rows*muDTrpsv.cols);

  if (mu->rows != mv->rows ||
      mu->cols != mv->cols ||
      mu->rows != 1
     )
    {
     printf(" uv_uvT() error.\n\n");

     printf(" u.rows = v.rows\n");
     printf(" u.cols = v.cols\n");
     printf(" u.rows = 1\n");

     printf("\nPress Return to continue\n");
     getchar();
     exit(1);
    }

  ctranspose_mZ(mv,&mTrpsv);
         mul_mZ( mu,mD,&muD);
         mul_mZ(&muD,&mTrpsv,&muDTrpsv);

  InnerProduct.r = *(muDTrpsv.pb+0 *muDTrpsv.cols   );
  InnerProduct.i = *(muDTrpsv.pb+0 *muDTrpsv.cols+C1);

	  free(muD.pB);
			   free(mT_D.pB);
			   free(mTrpsv.pB);
			   free(muDTrpsv.pB);

  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ normP2_w_Z(
PmZ mD,
PmZ mu
)
{
complexZ NormP2;

         NormP2 = innerprod_w_Z(mD,mu,mu);

  return(NormP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ distanceP2_w_Z(
PmZ mD,
PmZ mu,
PmZ mv
)
{
complexZ DistanceP2;

//MAT_TYPE pu_mns_v [MXR][MXC*C2];
//mZ mu_mns_v={MXR, MXC*C2,&pu_mns_v[0][0]};

mZ mu_mns_v;

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

	   mu_mns_v.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mu_mns_v.rows*mu_mns_v.cols);

      sub_mZ(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_w_Z(mD,&mu_mns_v);

  free(mu_mns_v.pB);

  return(DistanceP2);
}


