
#ifndef MECH_H
#define MECH_H

#include "equivalence.h"
#include "generalization.h"
#include "readData.h"
#include "predicate.h"


#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif

struct mechGroup_s
{
	int noOfMember;
	int noOfSen;

	int *member;
	int *isSen;

	int *noOfEachSen;
};

typedef struct mechGroup_s mechGroup;

struct mechAllGroup_s
{
	int noOfGroup;

	mechGroup **grouping;
};

typedef struct mechAllGroup_s mechAllGroup;

struct twoTable_s
{
	data *qidTable;
	data *senTable;
};

typedef struct twoTable_s twoTable;


mechGroup *mechGroup_new();
void mechGroup_free(mechGroup *aMechGroup);
void mech_insert(mechGroup *aMechGroup, int id, int isSen, int senValue);

int mech_isAllSameQIDInAMechGroup(mechGroup *aMechGroup, data *dataSet, int noOfQID);
int mech_isAllSameQIDTwoMechGroup(mechGroup *aMechGroup1, mechGroup *aMechGroup2, data *dataSet, int noOfQID);
mechGroup *mech_mergeMechGroup(mechGroup *aMechGroup1, mechGroup *aMechGroup2, int noOfValueInSenAttr);

mechAllGroup *mechAllGroup_new();
void mechAllGroup_free(mechAllGroup *aMechAllGroup);
void mechAllGroup_insert(mechAllGroup *aMechAllGroup, mechGroup **aMechGroup);
void mechAllGroup_remove(mechAllGroup *aMechAllGroup, int index);

int mech_findParentCoverage_dim(generalizedDimTable *genDimTable, dimension *dim1, dimension *dim2);

double mech_calculateDistanceBetweenTwoClass(int id1, int id2, data *dataSet, int noOfQID, generalizedAllTable *genAllTable);
double mech_calculateDistanceBetweenClassMechGroup(int id, mechGroup *aMechGroup, data *dataSet, int noOfQID, generalizedAllTable *genAllTable);

int mech_findCoverage_dim(dimension *aDim, generalizedDimTable *genDimTable);

mechAllGroup *transformFromEqClassToMechAllGroup(equivalenceClass *eqClass, int noOfValueInSenAttr);

int isMech(equivalenceClass *proEqClass, configure *conf, int noOfValueInSenAttr);

double calculateAvgRelativeError(mechAllGroup *aMechAllGroup, allCondition *aAllCondition, data *dataSet, int noOfQID);
twoTable *generateTwoTableFromMechGroup(mechAllGroup *aMechAllGroup, data *dataSet);

#endif
