
#include "possWorld.h"

int **possWorld_createAllPossPositionForOneValue(int noOfElt, int maxSize, int *noOfPoss)
{
	int **returnValue;

	int index;

	int i, j, k;

	int noOfPoss_small;
	int **allPoss_small;

	int offset;

	if (noOfElt == 0)
	{
		returnValue = NULL;
		(*noOfPoss) = 0;
	}
	else if (noOfElt == 1)
	{
		
		(*noOfPoss) = maxSize;
		returnValue = (int **) malloc(sizeof(int *)*maxSize);

		for (i = 0; i < maxSize; i++)
		{
			returnValue[i] = (int *) malloc(sizeof(int));
			returnValue[i][0] = i;
		}
	}
	else
	{
		if (noOfElt > maxSize)
		{
			returnValue = NULL;
			(*noOfPoss) = 0;
		}
		else
		{
			(*noOfPoss) = (int) calculateCombination(maxSize, noOfElt);

			returnValue = (int **) malloc(sizeof(int *)*((*noOfPoss)));

			index = 0;

			for (i = 1; i <= maxSize; i++)
			{
				offset = i;

				allPoss_small = possWorld_createAllPossPositionForOneValue(noOfElt-1, maxSize-i, &noOfPoss_small);

				if (allPoss_small != NULL)
				{
					for (j = 0; j < noOfPoss_small; j++)
					{
						returnValue[index] = (int *) malloc(sizeof(int)*noOfElt);

						returnValue[index][0] = i-1;
						//memcpy(&(returnValue[index][1]), allPoss_small[j], sizeof(int)*(noOfElt-1));
						for (k = 0; k < noOfElt-1; k++)
						{
							returnValue[index][1+k] = allPoss_small[j][k] + offset;
						}

						index++;

						free(allPoss_small[j]);
					}
					free(allPoss_small);
				}
			}
		}
	}

	return returnValue;
}

int **possWorld_createAllPossPositionForAllValue(int startIndex, int *noOfElt, int noOfSen, int maxSize, int *noOfPoss)
{
	int **returnValue;
	int i, j, k;

	int aValue;

	int index;

	int noOfPoss_small;
	int noOfPoss_base;

	int **allPoss_small;
	int **allPoss_base;

	int *tempList;

	int aPoss;

	int index_mapping;
	int *mapping;
	int *isOccupy;

	int tempSize;

	int anIndex;
//printf("   ((((((((((((((((1 (startIndex=%d, noOfSen=%d, maxSize=%d, noOfElt[startIndex]=%d)\n", startIndex, noOfSen, maxSize, noOfElt[startIndex]);
	if (startIndex >= noOfSen)
	{
//printf("   ((((((((((((((((2\n");
		returnValue = NULL;
		(*noOfPoss) = 0;
	}
	else if (noOfElt[startIndex] == 0)
	{
//printf("   ((((((((((((((((3\n");
		returnValue = possWorld_createAllPossPositionForAllValue(startIndex+1, noOfElt, noOfSen, maxSize-noOfElt[startIndex], noOfPoss);
	}
	else if (noOfElt[startIndex] == maxSize)
	{
//printf("   ((((((((((((((((4\n");
		(*noOfPoss) = 1;
		returnValue = (int **) malloc(sizeof(int *)*1);
		returnValue[0] = (int *) malloc(sizeof(int)*maxSize);
		for (i = 0; i < maxSize; i++)
		{
			returnValue[0][i] = startIndex;
		}
	}
	else
	{

//printf("   ((((((((((((((((5\n");		

		{

			// noOfPoss
			(*noOfPoss) = 1;
			tempSize = maxSize;
			for (i = startIndex; i < noOfSen; i++)
			{
				aValue = (int) calculateCombination(tempSize, noOfElt[i]);
				(*noOfPoss) *= aValue;

				tempSize -= noOfElt[i];
			}

			tempList = (int *) malloc(sizeof(int)*maxSize);
			
//printf("   ((((((((((((((((6\n");
			returnValue = (int **) malloc(sizeof(int *)*(*noOfPoss));
			for (i = 0; i < (*noOfPoss); i++)
			{
				returnValue[i] = (int *) malloc(sizeof(int)*maxSize);
			}
//printf("   ((((((((((((((((7\n");
			index = 0;
			allPoss_base = possWorld_createAllPossPositionForOneValue(noOfElt[startIndex], maxSize, &noOfPoss_base);
			for (i = 0; i < noOfPoss_base; i++)
			{
				// 
				memset(tempList, 0, sizeof(int)*maxSize);

				isOccupy = (int *) malloc(sizeof(int)*maxSize);
				memset(isOccupy, 0, sizeof(int)*maxSize);
				for (k = 0; k < noOfElt[startIndex]; k++)
				{
					aPoss = allPoss_base[i][k];

					tempList[aPoss] = startIndex;

					isOccupy[aPoss] = 1;			
				}
//printf("   ((((((((((((((((8\n");
				if (maxSize-noOfElt[startIndex] > 0)
				{
					// generate mapping
					index_mapping = 0;
					mapping = (int *) malloc(sizeof(int)*(maxSize-noOfElt[startIndex]));
					memset(mapping, 0, sizeof(int)*(maxSize-noOfElt[startIndex]));
					for (k = 0; k < maxSize; k++)
					{
						if (isOccupy[k] == 0)
						{
							mapping[index_mapping] = k;
							index_mapping++;
						}
					}
					free(isOccupy);
//printf("   ((((((((((((((((9\n");
					allPoss_small = possWorld_createAllPossPositionForAllValue(startIndex+1, noOfElt, noOfSen, maxSize-noOfElt[startIndex], &noOfPoss_small);
					if (noOfPoss_small > 0)
					{
						for (j = 0; j < noOfPoss_small; j++)
						{
							memcpy(returnValue[index], tempList, sizeof(int)*maxSize);

							// new
							for (k = 0; k < maxSize-noOfElt[startIndex]; k++)
							{
								anIndex = mapping[k];
								returnValue[index][anIndex] = allPoss_small[j][k];				
							}
							index++;
//printf("   ((((((((((((((((10\n");
							free(allPoss_small[j]);
						}
						free(allPoss_small);
					}

					free(mapping);
				}

				free(allPoss_base[i]);
			}
//printf("   ((((((((((((((((11\n");
			free(allPoss_base);

			free(tempList);
		}
	}


	return returnValue;

}

void test_createAllPossPositionForOneValue()
{
	int **allPoss;
	int noOfPoss;

	int noOfElt, maxSize;

	int i, j;

	noOfElt = 4;
	maxSize = 6;

	allPoss = possWorld_createAllPossPositionForOneValue(noOfElt, maxSize, &noOfPoss);

	for (i = 0; i < noOfPoss; i++)
	{
		printf("Poss. %d... ", i);
		for (j = 0; j < noOfElt; j++)
		{
			printf("%d ", allPoss[i][j]);
		}
		printf("\n");
	}
}


void test_createAllPossPositionForAllValue()
{
	int **allPoss;

	int i, j;

	int startIndex, noOfSen, maxSize, noOfPoss;
	int *noOfElt;

	startIndex = 0;
	noOfSen = 3;
	maxSize = 6;

	noOfElt = (int *) malloc(sizeof(int)*noOfSen);

	noOfElt[0] = 2;
	noOfElt[1] = 0;
	noOfElt[2] = 4;

	allPoss = possWorld_createAllPossPositionForAllValue(startIndex, noOfElt, noOfSen, maxSize, &noOfPoss);

	for (i = 0; i < noOfPoss; i++)
	{
		printf("Poss. %d: ", i);
		for (j = 0; j < maxSize; j++)
		{
			printf("%d ", allPoss[i][j]);
		}
		printf("\n");
	}
}



void test_createAllPossPositionForAllValue2()
{
	int **allPoss;

	int i, j;

	int startIndex, noOfSen, maxSize, noOfPoss;
	int *noOfElt;

	startIndex = 0;
	noOfSen = 16;
	maxSize = 12;

	noOfElt = (int *) malloc(sizeof(int)*noOfSen);

	noOfElt[0] = 0;
	noOfElt[1] = 1;
	noOfElt[2] = 0;
	noOfElt[3] = 3;
	noOfElt[4] = 0;
	noOfElt[5] = 0;
	noOfElt[6] = 0;
	noOfElt[7] = 1;
	noOfElt[8] = 0;
	noOfElt[9] = 0;
	noOfElt[10] = 1;
	noOfElt[11] = 0;
	noOfElt[12] = 1;
	noOfElt[13] = 2;
	noOfElt[14] = 1;
	noOfElt[15] = 2;

	allPoss = possWorld_createAllPossPositionForAllValue(startIndex, noOfElt, noOfSen, maxSize, &noOfPoss);

	for (i = 0; i < noOfPoss; i++)
	{
		printf("Poss. %d: ", i);
		for (j = 0; j < maxSize; j++)
		{
			printf("%d ", allPoss[i][j]);
		}
		printf("\n");
	}
}



int possWorld_isAllHaveSameSig(equivalenceTuple *oneEqTuple)
{
	int returnValue;
	int *sigList;

	int aSigID;
	int compareSigID;

	int i;

	int noOfMember;

	noOfMember = oneEqTuple->noOfMember;
	sigList = oneEqTuple->signatureID;

	if (noOfMember == 0)
	{
		returnValue = 1;
	}
	else 
	{
		returnValue = 1;

		compareSigID = sigList[0];

		for (i = 1; i < noOfMember; i++)
		{
			aSigID = sigList[i];

			if (aSigID != compareSigID)
			{
				returnValue = 0;
				break;
			}
		}
	}

	return returnValue;
}

int **possWorld_createAllPossWorldFromOneEqClass(equivalenceTuple *oneEqTuple, int noOfSenValue, int *noOfPoss)
{
	int **returnValue;

	int noOfTuple;

	int *noOfEachSen;
	int startIndex;

	int **allPoss;

	int isAllSameSig;

	startIndex = 0;
	noOfTuple = oneEqTuple->noOfMember;
	noOfEachSen = oneEqTuple->noOfEachSen;

	// is all have members have the same signature
	isAllSameSig = possWorld_isAllHaveSameSig(oneEqTuple);
	if (isAllSameSig == 1)
	{
		allPoss = NULL;
		(*noOfPoss) = 0;
	}
	else
	{
//printf(" $$$$1 (startIndex=%d, noOfSenValue=%d, noOfTuple=%d, id=%d\n", startIndex, noOfSenValue, noOfTuple, oneEqTuple->id);
//{
//	int k;
//	for (k = 0; k < noOfTuple; k++)
//	{
//		printf("%d ", oneEqTuple->senValue[k]);
//	}
//	printf("\n");
//	for (k = 0; k < noOfSenValue; k++)
//	{
//		printf("%d ", oneEqTuple->noOfEachSen[k]);
//	}
//	printf("\n");
//}
		allPoss = possWorld_createAllPossPositionForAllValue(startIndex, noOfEachSen, noOfSenValue, noOfTuple, noOfPoss);
//printf(" $$$$2 \n");
	}
	returnValue = allPoss;

	return returnValue;
}

term *possWorld_createOneTermFromOnePossWorld(equivalenceTuple *eqTuple, int *aPossWorld, int noOfSenValue, int *sigMapping)
{
	term *returnValue;
	int i, j;

	int noOfMember;

	int memberID;
	int memberID1, memberID2;
	int *member;
	int sigID;
	int sigID1, sigID2;
	dimension *senValue;
	int aSenValue;

	int aSenValue1, aSenValue2; 
	int *noOfEachSen;

	int *isConstant;

	int noOfCurrentSen;

	float tempConstant;

	int isExistConstant;

	literal *aLiteralConstant;
	int *isPrune;
	int *noOfOccur;

	int noOfVar;
	int noOfTerm;
	term *aTermConstant;

	int varNo, exponent;

	int offset, index;

	literal *aLiteralVar;
	term *aTermVar;

	returnValue = term_new();


	noOfMember = eqTuple->noOfMember;
	member = eqTuple->member;
	senValue = eqTuple->senValue;
	noOfEachSen = eqTuple->noOfEachSen;
	isConstant = (int *) malloc(sizeof(int)*noOfMember);
	memset(isConstant, 0, sizeof(int)*noOfMember);
	for (i = 0; i < noOfMember; i++)
	{
		 memberID = member[i];
		 sigID = sigMapping[memberID];
		 if (sigID == -1)
		 {
			 isConstant[i] = 1;
		 }
	}

	// multiple all constant terms
	tempConstant = 1;
	for (i = 0; i < noOfMember; i++)
	{
		memberID = member[i];
		sigID = sigMapping[memberID];
		//aSenValue = senValue[i].value;
		aSenValue = aPossWorld[i];
		noOfCurrentSen = noOfEachSen[aSenValue];

		if (isConstant[i] == 1)
		{
			tempConstant *= (float)( noOfCurrentSen/((double)noOfMember));
		}
	}

	if (tempConstant != 1.0)
	{
		aLiteralConstant = literal_createLiteralFromConstant(tempConstant);
		
		isExistConstant = 1;
	}
	else
	{
		isExistConstant = 0;
	}

	// variable
	isPrune = (int *) malloc(sizeof(int)*noOfMember);
	memset(isPrune, 0, sizeof(int)*noOfMember);
	noOfOccur = (int *) malloc(sizeof(int)*noOfMember);
	memset(noOfOccur, 0, sizeof(int)*noOfMember);
	for (i = 0; i < noOfMember; i++)
	{
		noOfOccur[i] = 1;

		memberID1 = member[i];
		sigID1 = sigMapping[memberID1];
		aSenValue1 = aPossWorld[i];

		if ((isConstant[i] == 0) && (isPrune[i] == 0))
		{
			for (j = i+1; j < noOfMember; j++)
			{
				memberID2 = member[j];
				sigID2 = sigMapping[memberID2];
				aSenValue2 = aPossWorld[j];

				if ((isConstant[j] == 0) && (isPrune[j] == 0))
				{
					if ((sigID1 == sigID2) && (aSenValue1 == aSenValue2))
					{
						isPrune[j] = 1;
						noOfOccur[i]++;
					}
				}
			}
		}
	}

	// count
	noOfVar = 0;
	for (i = 0; i < noOfMember; i++)
	{
		if ((isConstant[i] == 0) && (isPrune[i] == 0))
		{
			noOfVar++;
		}
	}

	if (noOfVar == 0)
	{
		// i.e. there is a constant term
		returnValue->noOfOperand = 1;
		returnValue->aLiteral = aLiteralConstant;
	}
	else if ((noOfVar == 1) && (isExistConstant == 0))
	{
		returnValue->noOfOperand = 1;
		
		index = 0;
		for (i = 0; i < noOfMember; i++)
		{
			memberID = member[i];
			sigID = sigMapping[memberID];
			//aSenValue = senValue[i].value;
			aSenValue = aPossWorld[i];
			//noOfCurrentSen = noOfEachSen[aSenValue];

			if ((isConstant[i] == 0) && (isPrune[i] == 0))
			{
				varNo = sigID*noOfSenValue + aSenValue;
				exponent = noOfOccur[i];
				aLiteralVar = literal_createLiteralFromVariable(varNo, exponent);

				returnValue->aLiteral = aLiteralVar;

				//aTermVar = term_createTermFromLiteral(aLiteralVar);

				//returnValue->operandList[offset+index] = aTermVar;
				//index++;

				break;
			}
		}
	}
	else
	{

		if (isExistConstant == 1)
		{
			noOfTerm = noOfVar+1;
			aTermConstant = term_createTermFromLiteral(aLiteralConstant);
		}
		else
		{
			noOfTerm = noOfVar;
		}

		returnValue->noOfOperand = noOfTerm;
		returnValue->operandList = (term **) malloc(sizeof(term *)*noOfTerm);

		if (isExistConstant == 1)
		{
			returnValue->operandList[0] = aTermConstant;
			offset = 1;
		}
		else
		{
			offset = 0;
		}

		

		index = 0;
		for (i = 0; i < noOfMember; i++)
		{
			memberID = member[i];
			sigID = sigMapping[memberID];
			//aSenValue = senValue[i].value;
			aSenValue = aPossWorld[i];
			//noOfCurrentSen = noOfEachSen[aSenValue];

			if ((isConstant[i] == 0) && (isPrune[i] == 0))
			{
				varNo = sigID*noOfSenValue + aSenValue;
				exponent = noOfOccur[i];
				aLiteralVar = literal_createLiteralFromVariable(varNo, exponent);

				aTermVar = term_createTermFromLiteral(aLiteralVar);

				returnValue->operandList[offset+index] = aTermVar;
				index++;
			}
		}

		// create operation
		returnValue->operationList = (int *) malloc(sizeof(int)*returnValue->noOfOperand);
		for (i = 0; i < returnValue->noOfOperand; i++)
		{
			returnValue->operationList[i] = OP_MULT;
		}
	}

	free(isPrune);
	free(noOfOccur);

	

	free(isConstant);

	return returnValue;
}

term **possWorld_createAllTermFromAllPossWorld(equivalenceTuple *eqTuple, int **allPoss, int noOfPoss, int noOfSenValue, int *sigMapping)
{
	term **returnValue;
	int i;

	int *onePoss; 

	if (noOfPoss == 0)
	{
		// all sig have the same values

		returnValue = NULL;
		
	}
	else
	{

		returnValue = (term **) malloc(sizeof(term *)*noOfPoss);
		for (i = 0; i < noOfPoss; i++)
		{
			onePoss = allPoss[i]; 
			returnValue[i] = possWorld_createOneTermFromOnePossWorld(eqTuple, onePoss, noOfSenValue, sigMapping);
		}
	}

	return returnValue;
}


// NULL: if noOfPoss = 0;
term *possWorld_createDivisor(term **allTerm, int noOfPoss)
{
	term *returnValue;

	term *aTerm;
	int i;

	

	if (noOfPoss == 0)
	{
		returnValue = NULL;
	}
	else if (noOfPoss == 1)
	{
		//returnValue = term_new();

		//returnValue->noOfOperand = 1;
		//returnValue->aLiteral = literal_new();
		//literal_copy(returnValue->aLiteral, allTerm[0]->aLiteral);

		returnValue = term_clone(allTerm[0]);
	}
	else
	{
		returnValue = term_new();

		returnValue->noOfOperand = noOfPoss;
		returnValue->operandList = (term **) malloc(sizeof(term *)*noOfPoss);
		returnValue->operationList = (int *) malloc(sizeof(int)*noOfPoss);

		for (i = 0; i < noOfPoss; i++)
		{
			
			aTerm = term_clone(allTerm[i]);
			returnValue->operandList[i] = aTerm;
			returnValue->operationList[i] = OP_SUM;
		}
	}

	return returnValue;
}

//*** 1
// NULL: if we cannot find sigID in the equivalence class
term *createAllTermForProbLinkageWithOneEqTuple(equivalenceTuple *oneEqTuple, term **allTerm, int **allPoss, int noOfPoss, int sigID, int aSenValue, term *divisor1)
{
	term *returnValue;
	int i;

	//int *isFlag;

	term *aTerm;

	term *dividend;
	//*** 1
	term *divisor;

	int noOfSatisfy;

	int memberID;
	int index;

	int noOfMember;
	int noOfSenValue;
	float probLinkage;

	

	//isFlag = (int *) malloc(sizeof(int)*noOfPoss);
	//memset(isFlag, 0, sizeof(int)*noOfPoss);

	// find memberID
	memberID = -1;
	for (i = 0; i < oneEqTuple->noOfMember; i++)
	{
		if (oneEqTuple->signatureID[i] == sigID)
		{
			memberID = i;
			break;
		}
	}

	if (memberID == -1)
	{
		returnValue = NULL;
	}
	else if (noOfPoss == 0)
	{
		noOfMember = oneEqTuple->noOfMember;
		noOfSenValue = oneEqTuple->noOfEachSen[aSenValue];
		probLinkage = (float) (noOfSenValue/ ((double) noOfMember));


		returnValue = term_new();
		returnValue->noOfOperand = 1;
		
		returnValue->aLiteral = literal_createLiteralFromConstant(probLinkage);
	}
	else if (noOfPoss == 1)
	{
		returnValue = term_new();
		returnValue->noOfOperand = 1;

		// must have one elt
		if (oneEqTuple->senValue[0].value == aSenValue)
		{
			// must be equal to one
			returnValue->aLiteral = literal_createLiteralFromConstant(1.0f);
		}
		else
		{
			// must be equal to one
			returnValue->aLiteral = literal_createLiteralFromConstant(0.0f);
		}

		
	}
	else
	{
		returnValue = term_new();

		noOfSatisfy = 0;
		for (i = 0; i < noOfPoss; i++)
		{
			if (allPoss[i][memberID] == aSenValue)
			{
				//
				noOfSatisfy++;
			}
		}

		if (noOfSatisfy == 0)
		{
			returnValue->noOfOperand = 1;
			returnValue->aLiteral = literal_createLiteralFromConstant(0);
		}
		else if (noOfSatisfy == 1)
		{
			//**** here
			for (i = 0; i < noOfPoss; i++)
			{
				if (allPoss[i][memberID] == aSenValue)
				{
					//
					aTerm = term_clone(allTerm[i]);
					dividend = aTerm;

					break;
				}
			}
		}
		else
		{
			dividend = term_new();

			dividend->noOfOperand = noOfSatisfy;
			dividend->operandList = (term **) malloc(sizeof(term *)*noOfSatisfy);
			dividend->operationList = (int *) malloc(sizeof(int)*noOfSatisfy);

			index = 0;
			for (i = 0; i < noOfPoss; i++)
			{
				if (allPoss[i][memberID] == aSenValue)
				{
					//
					aTerm = term_clone(allTerm[i]);
					dividend->operandList[index] = aTerm;
					dividend->operationList[index] = OP_SUM;
					index++;
				}
			}
		}

		if (noOfSatisfy != 0)
		{
			//*** 1
			divisor = possWorld_createDivisor(allTerm, noOfPoss);

			returnValue->noOfOperand = 2;
			returnValue->operandList = (term **) malloc(sizeof(term *)*returnValue->noOfOperand);
			returnValue->operationList = (int *) malloc(sizeof(int)*returnValue->noOfOperand);

			returnValue->operandList[0] = dividend;
			returnValue->operandList[1] = divisor;

			returnValue->operationList[0] = OP_DIVIDE;
			returnValue->operationList[0] = OP_DIVIDE;
		}
	}

	return returnValue;
}

int possWorld_findNoOfMatchInOneEqClass(equivalenceTuple *oneEqTuple, int sigID)
{
	int noOfOccur;

	int i;

	int noOfMember;
	int *sigIDList;

	noOfMember = oneEqTuple->noOfMember;
	sigIDList = oneEqTuple->signatureID;


	noOfOccur = 0;
	for (i = 0; i < noOfMember; i++)
	{
		if (sigID == sigIDList[i])
		{
			noOfOccur++;
		}
	}

	return noOfOccur;
}

// re-use probLinkTerm
term *createProbLinkTermWithMultiplyCount(equivalenceTuple *oneEqTuple, term *probLinkTerm, int sigID)
{
	term *returnValue;
	int noOfMember;
	
	int *sigIDList;

	literal *aLiteral;
	literal *aLiteralConstant;
	term *aTermConstant;

	term *aTermFirst;

	//term **newOperandList;
	//term **oldOperandList;

	//int *newOperationList;
	//int *oldOperationList;

	int noOfOccur;
	
	noOfMember = oneEqTuple->noOfMember;
	sigIDList = oneEqTuple->signatureID;
	
	noOfOccur = possWorld_findNoOfMatchInOneEqClass(oneEqTuple, sigID);
	
	 
	if (noOfOccur == 0)
	{
		term_free(probLinkTerm);

		returnValue = term_new();
		returnValue->noOfOperand = 1;
		returnValue->aLiteral = literal_createLiteralFromConstant(0);
	}
	else if (noOfOccur == 1)
	{
		returnValue = probLinkTerm;
	}
	else
	{
		

		// check whether there is a constant
		if (probLinkTerm->noOfOperand == 1)
		{
			returnValue = term_new();

			aLiteral = probLinkTerm->aLiteral;
			if (aLiteral->isConstant == 1)
			{
				aLiteral->value *= noOfOccur;

				returnValue->noOfOperand = 1;
				returnValue->aLiteral = aLiteral;

				free(probLinkTerm);
			}
			else
			{
				returnValue->noOfOperand = 2;
				returnValue->operandList = (term **) malloc(sizeof(term *)*2);
				returnValue->operationList = (int *) malloc(sizeof(int)*2);

				aLiteralConstant = literal_createLiteralFromConstant((float)noOfOccur);
				aTermConstant = term_createTermFromLiteral(aLiteralConstant);

				returnValue->operandList[0] = aTermConstant;
				returnValue->operandList[1] = probLinkTerm;

				returnValue->operationList[0] = OP_MULT;
				returnValue->operationList[1] = OP_MULT;
			}
		}
		else
		{
			returnValue = probLinkTerm;

			// pick the first term
			aTermFirst = probLinkTerm->operandList[0];

			if ((aTermFirst->noOfOperand == 1) && (aTermFirst->aLiteral->isConstant == 1))
			{
				
				aTermFirst->aLiteral->value *= noOfOccur;
			}
			else
			{
				returnValue = term_new();


				returnValue->noOfOperand = 2;
				returnValue->operandList = (term **) malloc(sizeof(term *)*2);
				returnValue->operationList = (int *) malloc(sizeof(int)*2);

				aLiteralConstant = literal_createLiteralFromConstant((float)noOfOccur);
				aTermConstant = term_createTermFromLiteral(aLiteralConstant);

				returnValue->operandList[0] = aTermConstant;
				returnValue->operandList[1] = probLinkTerm;

				returnValue->operationList[0] = OP_MULT;
				returnValue->operationList[1] = OP_MULT;

				
			}


		}
	}

	return returnValue;
}

term *possWorld_createExpressionForOneVariable(int sigID, int senID, int noOfSenValue, int noOfTupleForThisSig, equivalenceClass *eqClass, term ***allTerm, int ***allPoss, int *noOfPoss)
{
	term *returnValue;

	equivalenceTuple *oneEqTuple;

	int noOfEqTuple;
	equivalenceTuple **eqTupleList;

	int i;

	int eqID;

	int *eqIDMatchList;
	int noOfMatch;

	term *probLinkTerm;
	term *fixTerm;

	literal *aLiteralNoOfTupleForThisSig;
	literal *aLiteralThisVar;

	int varNo;

	term *divisor;

	term *probLinkTermMultiplyCount;

	eqTupleList = eqClass->eqClass;
	noOfEqTuple = eqClass->noOfEqClass;

	returnValue = term_new();

	eqIDMatchList = sig_findEqClassWithSignature(eqClass, sigID, &noOfMatch);

	returnValue->noOfOperand = noOfMatch+1;
	returnValue->operandList = (term **) malloc(sizeof(term *)*(noOfMatch+1));
	returnValue->operationList = (int *) malloc(sizeof(int)*(noOfMatch+1));

	// for the first term
	fixTerm = term_new();
	fixTerm->noOfOperand = 2;
	fixTerm->operandList = (term **) malloc(sizeof(term *)*fixTerm->noOfOperand);
	fixTerm->operationList = (int *) malloc(sizeof(int)*fixTerm->noOfOperand);

	varNo = sigID*noOfSenValue + senID;
	aLiteralNoOfTupleForThisSig = literal_createLiteralFromConstant( (float) noOfTupleForThisSig);
	aLiteralThisVar = literal_createLiteralFromVariable(varNo, 1);

	fixTerm->operandList[0] = term_createTermFromLiteral(aLiteralNoOfTupleForThisSig);
	fixTerm->operandList[1] = term_createTermFromLiteral(aLiteralThisVar);
	fixTerm->operationList[0] = OP_MULT;
	fixTerm->operationList[1] = OP_MULT;


	returnValue->operandList[0] = fixTerm;
	returnValue->operationList[0] = OP_MINUS;


	// for the remaining term
	for (i = 0; i < noOfMatch ; i++)
	{
		eqID = eqIDMatchList[i];

		oneEqTuple = eqTupleList[eqID];

		//*** 1
		// special case for non-sensitive value
		//if (oneEqTuple->noOfMember = oneEqTuple->noOfEachSen[0])
		{
			divisor = NULL;
		}
		//else
		{
			//divisor = possWorld_createDivisor(allTerm[eqID], noOfPoss[eqID]);
		}

		probLinkTerm = createAllTermForProbLinkageWithOneEqTuple(oneEqTuple, allTerm[eqID], allPoss[eqID], noOfPoss[eqID], sigID, senID, divisor);

		probLinkTermMultiplyCount = createProbLinkTermWithMultiplyCount(oneEqTuple, probLinkTerm, sigID);

		returnValue->operandList[i+1] = probLinkTermMultiplyCount;
		returnValue->operationList[i+1] = OP_MINUS;
	}
	free(eqIDMatchList);

	return returnValue;
}

term **possWorld_createExpressionForAllVariable(term ****allTerm_in, int ****allPoss_in, int **noOfPoss_in, int noOfSenValue, equivalenceClass *eqClass, int noOfTuple, signatureGroup *aSignatureGroup, int *mapTupleList)
{
	term **returnValue;
	int noOfSignature;
	int i, j;

	

	int sigID, senID;

	int noOfResult;
	int noOfTupleForThisSig;

	term ***allTerm;
	int ***allPoss;
	int *noOfPoss;

	int noOfEqTuple;
	int varNo;
	equivalenceTuple **eqTupleList;

	signature *aSignature;

	equivalenceTuple *oneEqTuple;

	noOfSignature = aSignatureGroup->noOfSig;

	noOfResult = noOfSignature*noOfSenValue;

	returnValue = (term **) malloc(sizeof(term *)*noOfResult);

	

	noOfEqTuple = eqClass->noOfEqClass;
	eqTupleList = eqClass->eqClass;

	// find all poss. case for each equivalence class
	allPoss = (int ***) malloc(sizeof(int **)*noOfEqTuple);
	memset(allPoss, 0, sizeof(int **)*noOfEqTuple);
	noOfPoss = (int *) malloc(sizeof(int)*noOfEqTuple);
	memset(noOfPoss, 0, sizeof(int)*noOfEqTuple);
	allTerm = (term ***) malloc(sizeof(term **)*noOfEqTuple);
	memset(allTerm, 0, sizeof(term **)*noOfEqTuple);
	for (i = 0; i < noOfEqTuple; i++)
	{
		oneEqTuple = eqTupleList[i];
		if (i == 4)
		{
			printf("");
		}

		//printf(" %d (noOfEqTuple=%d)\n", i, noOfEqTuple);
		allPoss[i] = possWorld_createAllPossWorldFromOneEqClass(oneEqTuple, noOfSenValue, &(noOfPoss[i]));
		//printf(" %d (noOfEqTuple=%d)\n", i, noOfEqTuple);
		allTerm[i] = possWorld_createAllTermFromAllPossWorld(oneEqTuple, allPoss[i], noOfPoss[i], noOfSenValue, mapTupleList);

	}

	// fine output
	for (i = 0; i < noOfSignature; i++)
	{
		sigID = i;

		aSignature = aSignatureGroup->sigList[i];
		noOfTupleForThisSig = aSignature->noOfMember;
		

		for (j = 0; j < noOfSenValue; j++)
		{
			senID = j;

			if ((i == 2) && (j == 0))
			{
				printf("");
			}

			varNo = i*noOfSenValue + j;
			returnValue[varNo] = possWorld_createExpressionForOneVariable(sigID, senID, noOfSenValue, noOfTupleForThisSig, eqClass, allTerm, allPoss, noOfPoss);

			if ((i == 2) && (j == 0))
			{
				printf("");
			}
			//printf("(%d, %d)\n", i, j);
			//term_print(returnValue[varNo]);
			//printf("\n");
		}
	}

	(*allTerm_in) = allTerm;
	(*allPoss_in) = allPoss;
	(*noOfPoss_in) = noOfPoss;

	// free
/*	for (i = 0; i < noOfEqTuple; i++)
	{
		if (allPoss[i] != NULL)
		{
			free(allPoss[i]);
		}
		if (allTerm[i] != NULL)
		{
			free(allTerm[i]);
		}
	}
	free(allPoss);
	free(noOfPoss);
	free(allTerm);
*/

	return returnValue;
}

void mainPossWorld()
//void main()
{
	//test_createAllPossPositionForOneValue();
	//test_createAllPossPositionForAllValue();
	test_createAllPossPositionForAllValue2();
}


