
#ifndef SIG_H
#define SIG_H

#include "readData.h"
#include "equivalence.h"

struct signature_s
{
	int noOfAttr;

	int *dimNo;
	dimension *content;

	int noOfMember;

	int *member;

	float *prob;

	int *senCount;
};

typedef struct signature_s signature;


struct signatureGroup_s
{
	int noOfSig;

	signature **sigList;
};

typedef struct signatureGroup_s signatureGroup;

struct signatureGroupGroup_s
{
	int noOfGroup;

	signatureGroup **groupList;
};

typedef struct signatureGroupGroup_s signatureGroupGroup;

struct signatureGroupGroupGroup_s
{
	int noOfSize;

	signatureGroupGroup **sizeList;
};

typedef struct signatureGroupGroupGroup_s signatureGroupGroupGroup;

int *sig_findEqClassWithSignature(equivalenceClass *eqClass, int sigID, int *noOfMatch);
void sig_createSigNoForAllEqClass(equivalenceClass *eqClass, int *mapTupleList);
int *sig_createTupleMapSignature(signatureGroup *aSignatureGroup, int noOfTuple);
signatureGroupGroup *sig_createRealSignatureForMultipleAttr(data *aData, int threshold);



signatureGroupGroup *sig_createSignatureGroupFromLowerLevel(signatureGroupGroup *aSigGroupGroup, int threshold);
void sigGroupGroup_free(signatureGroupGroup *aSigGroupGroup);


int ***sig_findGlobalDistributionFromOrgTable(configure *config, signatureGroupGroupGroup *allSig, data *aData, int noOfSenIndex);

signatureGroupGroupGroup *sig_findAllSignature(data *aData, int threshold);
void sig_printStatistics(FILE *filePtr, signatureGroupGroupGroup *allSig);
 

void sig_printSignatureGroupGroupGroup(FILE *filePtr, signatureGroupGroupGroup *allSig, int noOfSenIndex);

#endif

