
#ifndef TERM_H
#define TERM_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define LIT_TYPE float

#define OP_SUM 1 
#define OP_MINUS 2
#define OP_MULT 3 
#define OP_DIVIDE 4

struct literal_s
{
	int isConstant;
	LIT_TYPE value;
	int exponent;
};

typedef struct literal_s literal;


typedef struct term_s term;

struct term_s
{
	literal *aLiteral;

	int noOfOperand;

	term **operandList;
	int *operationList;

	int exponent;
};


literal *literal_createLiteralFromConstant(LIT_TYPE aNo);
literal *literal_createLiteralFromVariable(int varNo, int exponent);
void literal_copy(literal *aLiteral1, literal *aLiteral2);

term *term_createTermFromLiteral(literal *aLiteral);

literal *literal_new();
term *term_new();
literal *term_getLiteral(term *aTerm);
void term_copySingle(term *aTerm1, term *aTerm2);
void term_copy(term *aTerm1, term *aTerm2);
term *term_clone(term *aTerm);

term *term_createTermFromLiteral(literal *aLiteral);


float term_calculateValue(term *aTerm, float *vector);

void term_free(term *aTerm);

void term_print(term *aTerm);

term *term_mergeLiteral(int noOfLiteral, literal **literalList, int operationNo);
term *term_mergeTerm(int noOfTerm, term **termList, int operationNo);

#endif
